function display_saltout(name,phase,filt)
%phase=1 make phase space plots, otherwise plot against time
if nargin < 3
  filt=1; % Size of filter
end
if nargin < 2
  phase = 0;
end
if nargin < 1
  name = '';
end

if isempty(name)
  name = '/home/jim/saltare/out/saltout.dat';
end
reclen=13;
fp=fopen(name,'r');
a = fscanf(fp,'%f');
fclose(fp);
n = floor(length(a)/reclen);
if reclen*n~=length(a)
  disp('warning: file is incomplete')
end
a = reshape(a(1:reclen*n),reclen,n);
a = moving_avg(a,filt,2); % Filter all quantities
iter   = a(1,:);
time   = a(2,:);
bot_fv = a(3,:);
top_fv = a(4,:);
bot_v  = a(5,:);
top_v  = a(6,:);
z0     = a(7,:);
num    = a(8,:);
mass   = a(9,:);
mom    = a(10,:);
imp    = a(11,:); 
down   = a(12,:); 
up     = a(13,:); 

[max_fv  half] = max 

  clf
  subplot(2,2,1);
  plot(top_fv,z0)
  title('Rougness height against friction velocity')
  ylabel('m')
  xlabel('m/s')
  axis tight

  subplot(2,2,2);
  plot(top_fv,imp)
  title('Grain stress against friction velocity')
  ylabel('N/m^2')
  xlabel('m/s')
  axis tight

  subplot(2,2,3);
  plot(top_fv,mass)
  title('Mass load against friction velocity')
  ylabel('Kg/m^2')
  xlabel('m/s')
  axis tight

  subplot(2,2,4);
  plot(top_fv,mom)
  title('Mass flux against friction velocity')
  ylabel('Kg/m/s')
  xlabel('m/s')
  axis tight
end



