function fv=calc_friction_vel(u,z,z0,k,myu,no_slip)
% Calculate fricitionn velocity
% Solve the equation
% f(y) = x - sqrt(1+y^2)+y*(asinh(y)-A) 
% df/dy = asinh(y)+A 
% y -> y - f(y)/(df/dy)
% y -> (sqrt(1+y^2)-x)/(asinh(y)+A)

z = z+z0;

if no_slip==1
  c = 2*k*z/myu;
  x = c*k*u;
  y = sqrt(2*x);
  for i=1:5
    y = (x+sqrt(1+y^2)-1)/asinh(y);
  end
  fv = y/c;
  nu = (1-sqrt(1+y^2)+y*asinh(y))/(c*k);
  disp(['Friction velocity ', num2str(fv)]);
  disp(['Top velocity ', num2str(nu)]);
else
  x = 2*k^2*z*u/myu-1;
  A = log(z/(2*z0));
  
  y = (1+x)/(1+A+log(2)); % Initial guess
  
  
  for i=1:5
    sy = sqrt(1+1/y^2);
    y = (x+y*(sy-1))/(log(1+sy)+A);
  end
  
  fv = myu*y/(2*k*z);
  
  disp(fv/k*((1-sqrt(1+y^2))/y + log(1+sqrt(1+1/y^2)) +1+A));
  disp(u/(1+x)*y*((1-sqrt(1+y^2))/y + log(1+sqrt(1+1/y^2)) +1+A));
end
