function fv=calc_friction_vel3(u1,z1,u2,z2,k,myu)
% Calculate fricition velocity
% given u(z1) and u(z2)

c = 2*k^2/myu;
x = c*(u2-u1)-1/z2+1/z1;
y = sqrt(c*(u2-u1)/(z2-z1));
con_tol=1e-10;
maxit = 10;
for n=1:maxit
  oy = y;
  y = (x + sqrt(1+z2^2*y^2)/z2-sqrt(1+z1^2*y^2)/z1)/(asinh(z2*y)-asinh(z1*y));
  if(abs(y-oy)<=con_tol) 
    break
  end
end
fv = myu*y/(2*k);

a1 = u1-(1-sqrt(1+z1^2*y^2)+y*z1*asinh(z1*y))/(c*z1);
a2 = u2-(1-sqrt(1+z2^2*y^2)+y*z2*asinh(z2*y))/(c*z2);

a = (a1+a2)/2;

nu1 = a+(1-sqrt(1+z1^2*y^2)+y*z1*asinh(z1*y))/(c*z1);
nu2 = a+(1-sqrt(1+z2^2*y^2)+y*z2*asinh(z2*y))/(c*z2);

fv = myu*y/(2*k);

disp(['Friction velocity=', num2str(fv)]);
disp(['Constant=',num2str(a)]);
disp(['nu1-u1=',num2str(nu1-u1)]);
disp(['nu2-u2=',num2str(nu2-u2)]);
