function [nv,nx,dt,my] = calc_gendrag_trajs(v,x)
% Calculate a trajectiory for the saltation model
% the function wall_force_fnct is assumed to give the force
% the initial position is taken to be (0,0)
% and the initial velocity is u(1:2)
% the trajectory is integrated until it hits the ground
global tolerance

%options = odeset('OutputFcn','odephas2');
options = odeset('OutputFcn','','events','on',...
    'reltol',tolerance/100,'abstol',tolerance/100);

if nargin < 2
  x = zeros(size(v));
end
x = [x(:);v(:)];
dt =0;
% Find maximum height
if (x(4)>=0)
  [tt xx]=ode45('wall_force_fnct',[0 Inf],x,options);
  dt = tt(end);
  x = xx(end,:)';
end
% Find ground collision
my = x(2);
if (x(2)>tolerance)
  [tt xx]=ode45('wall_force_fnct',[0 Inf],x,options);
  dt = dt + tt(end);
  x = xx(end,:)';
end

nv = x(3:4);
nx = x(1:2);
