% Call after display profile so that the following variables are defined
% astress - air stress
% fluidu  - fluid velocity
% y       - grid points for astress
% my      _ grid points for fluid velocity

ay0 =repmat(my(1:end-1)',[1 nt]).^(fluidu(2:end,:)./diff(fluidu))./...
    repmat(my(2:end)',[1 nt]).^(fluidu(1:end-1,:)./diff(fluidu));
du = (fluidu(2:end,:)+fluidu(1:end-1,:))...
    ./(2*(fluidu(2:end,:)-fluidu(1:end-1,:)));
ay0 =repmat(sqrt(my(1:end-1).*my(2:end)),[nt 1])'...
    .*repmat(my(1:end-1)./my(2:end),[nt 1])'.^du;

% ay0 is completely out for small heights

by0 = repmat(my(:),[1 nt])...
    .*exp(-.41*fluidu./(sqrt((astress(1:end-1,:)+astress(2:end,:))/2.45)));

subplot(2,2,1)
mesh(log(y(2:ngp-1)),time,ay0');
axis tight
xlabel('log(y)')
ylabel('t')
zlabel('z0')
set(gca,'xdir','reverse')

subplot(2,2,2)
mesh(log(my),time,by0');
axis tight
xlabel('log(y)')
ylabel('t')
zlabel('z0')
set(gca,'xdir','reverse')

subplot(2,2,3)
h1=semilogx(y(2:ngp-1),ay0-(by0(1:end-1,:)+by0(2:end,:))/2);
axis tight
xlabel('log(y)')
ylabel('az0-bz0')

subplot(2,2,4)
plot(time,ay0(end,:),time,by0(end,:));
axis tight
title('roughness height at top');
xlabel('Time');
ylabel('z0');

