% Check that trajectories are correct when there is no air drag
global gravity

if length(gravity)==2
  g = abs(gravity(2));
else
  g = abs(gravity);
end

trj = read_traj;

n = length(trj.max_y);

% Perform no drag calculation
dt = 2*trj.start_vel(2,:)/g; % Exact trajectory duration

trj.new_t = trj.start_t + dt;
trj.new_max_y = trj.start_vel(2,:).^2/(2*g);
trj.new_vel(1,:) = trj.start_vel(1,:);
trj.new_vel(2,:) = -trj.start_vel(2,:);
trj.new_pos(1,:) = trj.start_pos(1,:)+dt.*trj.start_vel(1,:);
trj.new_pos(2,:) = 0;

compare_traj(trj);

