function [e,f]=compare_traj(trj)

tol = 1e-4; % 0.1mm

[e(:,1) f(:,1)] = calc_err(trj.end_t,trj.new_t,tol); % Check duration
[e(:,2) f(:,2)] = calc_err(trj.max_y,trj.new_max_y,tol);
[e(:,3) f(:,3)] = calc_err(trj.end_vel(1,:),trj.new_vel(1,:),tol);
[e(:,4) f(:,4)] = calc_err(trj.end_vel(2,:),trj.new_vel(2,:),tol);
[e(:,5) f(:,5)] = calc_err(trj.end_pos(1,:),trj.new_pos(1,:),tol);
[e(:,6) f(:,6)] = calc_err(trj.end_pos(2,:),trj.new_pos(2,:),tol);

str = '%14.12f %12.14f %i %i'; 
disp(sprintf('errors     absolute       relative %10.8f',tol))
disp(sprintf(['duration   ' str ],e(1,1),e(2,1),f(1,1),f(2,1)));
disp(sprintf(['max height ' str ],e(1,2),e(2,2),f(1,2),f(2,2)));
disp(sprintf(['end vel x  ' str ],e(1,3),e(2,3),f(1,3),f(2,3)));
disp(sprintf(['end vel y  ' str ],e(1,4),e(2,4),f(1,4),f(2,4)));
disp(sprintf(['end pos x  ' str ],e(1,5),e(2,5),f(1,5),f(2,5)));
disp(sprintf(['end pos y  ' str ],e(1,6),e(2,6),f(1,6),f(2,6)));



