name = '/home/jim/saltare/out/profile.bin';

y = read_grid;
my = (y(2:end)+y(1:end-1))/2;   % Grid mid points
dy = y(2:end)-y(1:end-1);       % Grid sizes

ngr = length(my);
ngp = length(y);

relen = 7*ngr + 2;
%iteration dummy time
ecm = cumsum([3 ngr ngr+1 ngr ngr  ngr  ngr]);
% Each profile consists of three records
cn = [1 2*ngr+1 4*ngr]; % Expected lengths of reals
relen=sum(cn);

%[x n]=read_fbin(name,'float64');
x=check_fbin(name,2,sum(cn),[],length(cn));
%if ~all(n == repmat(cn,[1 length(n)/4]))
%  error('Record length is not regular')
%end
%x = reshape(x,relen,sum(n)/relen);

iter = x(1,:);
time = x(3,:);
nt = length(time);

fluidu   = x(ecm(1)+1:ecm(2),:);
astress    = x(ecm(2)+1:ecm(3),:);

num_dens     = x(ecm(3)+1:ecm(4),:); % Number density
mass_dens    = x(ecm(4)+1:ecm(5),:); % Mass density
mom_dens     = x(ecm(5)+1:ecm(6),:); % Momentum density
imp_dens     = x(ecm(6)+1:ecm(7),:); % Impulse density / particle stress
imp_dens     = x(ecm(6)+1:ecm(7),:); % Impulse density / particle stress
imp_dens = cumsum(repmat(dy',[1 nt]).*imp_dens);
imp_dens = repmat(imp_dens(end,:),[ngr, 1])-imp_dens;

figure(1)
subplot(3,2,1)
mesh(log(my),time,fluidu')
xlabel('log(my)')
ylabel('time')
title('Fluid velocity')
axis tight

subplot(3,2,2)
mesh(log(y(2:end)),time,astress(2:end,:)')
xlabel('log(my)')
ylabel('time')
title('Air stress')
axis tight

subplot(3,2,3)
mesh(log(my),time,imp_dens')
xlabel('log(y)')
ylabel('time')
title('Grain stress')
axis tight

subplot(3,2,4)
mesh(log(my),time,astress(2:end,:)'+imp_dens')
xlabel('log(y)')
ylabel('time')
title('Total stress')
axis tight

subplot(3,2,5)
mesh(log(my),time,mom_dens')
xlabel('log(y)')
ylabel('time')
title('Grain momentum density')
axis tight

subplot(3,2,6)
mesh(log(my),time,mass_dens')
xlabel('log(my)')
ylabel('time')
title('mass load')
axis tight

figure (2)
subplot(6,1,1)
plot(time,dy*mom_dens)
title('Grain momentum (mass flux)')
ylabel('mass flux')
axis tight
subplot(6,1,2)
plot(time,dy*mass_dens)
title('Mass load')
ylabel('mass load')
axis tight
subplot(6,1,3)
plot(time,imp_dens(1,:))
title('Grain stress')
ylabel('grain stress')
axis tight
subplot(6,1,4)
plot(time,astress(1,:))
title('Ground shear stress')
ylabel('air stress')
axis tight
subplot(6,1,5)
plot(time,dy*fluidu)
title('Wind momentum')
axis tight
subplot(6,1,6)
plot(time,fluidu(1,:))
title('Ground wind speed')
axis tight

if 0
  figure(2)
  clf
  % To check accuracy
  a=check_fbin('/home/jim/saltare/wind.bin',0,ngr);
  subplot(2,1,1) 
  plot(log(my),fluidu)
  subplot(2,1,2) 
  plot((fluidu-repmat(a,[1 size(fluidu,2)]))/max(a))
end

