name = '/home/jim/saltare/traj.bin';
nymax = 42;

relen = 16; % Length of a record.
fp=fopen(name,'r','native');
a = fread(fp,'float32');
nrec = length(a)/relen;
a = reshape(a,relen,nrec);
fclose(fp);
fp=fopen(name,'r','native');
b = fread(fp,'int32');
nrec = length(b)/relen;
b = reshape(b,relen,nrec);
fclose(fp);


% Put into starting time order
[start_t i] = sort(a(5,:)); % starting position
blank_s  = b(1,i);
num      = b(2,i);
parent   = b(3,i);
origin   = b(4,i);
start_t  = a(5,i); % starting position
end_t    = a(6,i); % ending position
start_rx = a(7,i);
start_ry = a(8,i); % Looks odd
end_rx   = a(9,i); 
end_ry   = a(10,i); % And this is fucked
start_vx = a(11,i);
start_vy = a(12,i);
end_vx   = a(13,i);
end_vy   = a(14,i);
max_y    = a(15,i);
blank_e  = b(16,i);
if (any(blank_s/4~=relen-2) | any(blank_e/4~=relen-2))
  error('Record lengths mixed up')
end

aero = find(origin==1);
ricochet = find(origin==2);
splash = find(origin==3);
p = find(parent~=0);        % These are the grains with parents

if length(p)~=length(ricochet)+length(splash)
  disp('Parents and particle types are wrong.')
end
% Find the parents
ap = NaN*zeros(1,max(num));
ap(num) = 1:length(num);
np(p) = ap(parent(p));
if any(num(np(p)) ~= parent(p))
  error('Messed up parents')
end



set(0,'defaultlinemarkersize',1) 

figure(1)

subplot(2,2,1)
plot(start_vx(aero),start_vy(aero),'.')
title('Initial velocities aero')
subplot(2,2,2)
plot(start_vx(ricochet),start_vy(ricochet),'.')
title('Initial velocities ricochet')
subplot(2,2,3)
plot(start_vx(splash),start_vy(splash),'.')
title('Initial velocities splash')
subplot(2,2,4)
plot(start_vx,start_vy,'.')
title('Initial velocities all')
start_an = atan2(start_vy,start_vx)*180/pi;
end_an = atan2(start_vy,start_vx)*180/pi;

figure(2)
vsqr = sqrt(start_vx(ricochet).^2+start_vy(ricochet).^2);
vang = atan2(start_vy(ricochet),start_vx(ricochet))*180/pi;
in = np(ricochet);
vsqrp = sqrt(end_vx(in).^2+end_vy(in).^2);
vangp = atan2(end_vy(in),end_vx(in))*180/pi;

subplot(2,2,1)
plot(vang,vsqr./vsqrp,'.')
xlabel('In angle')
ylabel('Total restitution')
subplot(2,2,2)
plot(vang,start_vx(ricochet)./end_vx(in),'.')
xlabel('In angle')
ylabel('Horizontal restitution')
subplot(2,2,3)
plot(vang,-start_vy(ricochet)./end_vy(in),'.')
xlabel('In angle')
ylabel('Vertical restitution')
subplot(2,2,4)
plot(vangp,vang,'.')
xlabel('In angle')
ylabel('Out angle')


