function plot_collision(vin,vout,str)
% takes vin and vout
ang_in = atan2(-vin(2,:),vin(1,:))*180/pi;
spd_in = sqrt(sum(vin.^2));
ang_out = atan2(vout(2,:),vout(1,:))*180/pi;
spd_out = sqrt(sum(vout.^2));

subplot(2,2,1)
plot(ang_in,spd_out./spd_in,'.')
xlabel('In angle')
ylabel('Total restitution')
a = axis; axis([0 180 a(3) a(4)]);
title([str ' restitution as a function of angle'])

subplot(2,2,2)
plot(ang_in,ang_out,'.')
xlabel('In angle')
ylabel('Out angle')
title([str ' out angle as a function of in angle'])
a = axis; axis([0 180 0 180]);

subplot(2,2,3)
plot(ang_in,vout(1,:)./vin(1,:),'.')
xlabel('In angle')
ylabel('Horizontal restitution')
title([str ' horizontal restitution as a function of angle'])
a = axis; axis([0 180 max([-5 a(3)]) min([5 a(4)])]);

subplot(2,2,4)
plot(ang_in,-vout(2,:)./vin(2,:),'.')
xlabel('In angle')
ylabel('Vertical restitution')
title([str ' vertical restitution as a function of angle'])
a = axis; axis([0 180 max([-5 a(3)]) min([5 a(4)])]);

