function read_param(fn)
if nargin < 1
  fn = [getenv('SALT_HOME') '/out/param_pre.slt'];
end

global salt_p
global air_density air_viscosity roughness_height vkarman
global grain_density grain_diam gravity air_frictionv
global Cd_name grain_mass flat_wind tolerance 

salt_p=read_name_lists(fn);

gravity          = salt_p.track_nl.gravity(:);
tolerance        = salt_p.track_nl.tolerance;
Cd_name          = trim(salt_p.drag_nl.drag_type);
air_frictionv    = salt_p.wind_boundary_nl.bound_fnct_num;
air_density      = salt_p.wind_nl.air_density;
air_viscosity    = salt_p.wind_nl.air_viscosity;
flat_wind        = salt_p.wind_nl.flat_wind;
roughness_height = salt_p.wind_nl.yzero;
vkarman          = salt_p.wind_nl.vkarman;
grain_density    = salt_p.grain_nl.grain_dens;
grain_diam       = salt_p.grain_nl.grain_size(1);
grain_mass       = grain_density * pi * grain_diam^3/6;

% Adjust gravity for density difference
gravity = gravity*(1-air_density/grain_density);
