function t=read_traj(name)
if nargin <1
  name = '/home/jim/saltare/out/traj.bin';
end

%Format of this file is   
% int  - trajectory number
% int  - parent trajectory number
% int  - origin , aero, ricochet or splash
% int  - padding
% real - start time
% real - end time
% real - starting x coordinate
% real - starting y coordinate
% real - ending x coordinate
% real - ending y coordinate
% real - starting x velocity
% real - starting y velocity
% real - ending x velocity
% real - ending y velocity
% real - highest point (max y coordinate)
% int32
% float32

% 4 integers folowed by 11 floats
a=check_fbin(name,4,11);

% Put into starting time order
[start_t i] = sort(a(5,:)); % starting position


t.num       = a(1,i);
t.parent    = a(2,i);
t.origin    = a(3,i);
t.dummy     = a(4,i); % dummy integer used for nothing
t.start_t   = a(5,i); 
t.end_t     = a(6,i); 
t.start_pos = a(7:8,i);
t.end_pos   = a(9:10,i);
t.start_vel = a(11:12,i);
t.end_vel   = a(13:14,i);
t.max_y     = a(15,i);
