home = getenv('HOME');
name = [home '/saltare/out/profile.bin'];
sname = [home '/saltare/stress_test'];

[y fy] = read_grid;
my = (y(2:end)+y(1:end-1))/2;   % Grid mid points
vy = y(2:end)-y(1:end-1);       % Grid volumes

nymax = length(y)-1;

relen = 7*nymax + 2;
%iteration dummy time
ecm = cumsum([3 nymax nymax+1 nymax nymax  nymax  nymax]);
% Each profile consists of three records
cn = [1 2*nymax+1 4*nymax]; % Expected lengths of reals
relen=sum(cn);

%[x n]=read_fbin(name,'float64');
x=check_fbin(name,2,sum(cn),[],length(cn));
%if ~all(n == repmat(cn,[1 length(n)/4]))
%  error('Record length is not regular')
%end
%x = reshape(x,relen,sum(n)/relen);

iter = x(1,:);
time = x(3,:);

fluidu   = x(ecm(1)+1:ecm(2),:);
astress    = x(ecm(2)+1:ecm(3),:)';

num_dens     = x(ecm(3)+1:ecm(4),:); % Number density
mass_dens    = x(ecm(4)+1:ecm(5),:); % Mass density
mom_dens     = x(ecm(5)+1:ecm(6),:); % Momentum density
imp_dens     = x(ecm(6)+1:ecm(7),:); % Impulse density / particle stress
imp_dens     = [zeros(1,size(imp_dens,2));imp_dens];

stress = cumsum([0;check_fbin(sname,0,nymax,[])]);

yp = [NaN log(y(2:end))];
yp = y;
yp = 1:length(y);

subplot(3,1,1)
plot(yp,astress)
xlabel('log(y)')
ylabel('time')
title('Air stress')
axis tight

subplot(3,1,2)
plot(yp,stress)
xlabel('log(y)')
ylabel('time')
title('Grain stress')
axis tight

subplot(3,1,3)
plot(yp,astress+repmat(stress',[size(astress,1) 1]))
xlabel('log(y)')
ylabel('time')
title('Total stress')
axis tight
