global air_density air_viscosity roughness_height vkarman
global grain_density grain_diam gravity air_frictionv
global Cd_name grain_mass flat_wind tolerance

read_param;  
trj = read_traj;
nt = length(trj.max_y); % Number of trajectories

if flat_wind=='T' & (strcmp(Cd_name,'stokes') | strcmp(Cd_name,'none'))
  [trj.new_vel,trj.new_pos, dt, trj.new_max_y]=...
      calc_lindrag_trajs(trj.start_vel,trj.start_pos);
  trj.new_t = trj.start_t+dt;
  compare_traj(trj);
else
  disp('Integrating trajectories using calc_gendrag_trajs');
  for n=1:nt
    [trj.new_vel(:,n),trj.new_pos(:,n), dt, trj.new_max_y(:,n)]=...
	calc_gendrag_trajs(trj.start_vel(:,n),trj.start_pos(:,n));
    trj.new_t(n) = trj.start_t(n)+dt;
  end
  compare_traj(trj);
end