function [q,isterminal,direction]=wall_force_fnct(t,p,flag)
%p(1) = x position, q(1) = x velocity
%p(2) = y position, q(2) = y velocity
%p(3) = x velocity, q(3) = x acceleration
%p(4) = y velocity, q(4) = x acceleration
% Terminal events occur at end of trajectory and at maximum height
global grain_diam air_density air_viscosity gravity grain_density
global flat_wind air_frictionv
switch flag
  case ''                      % Return dy/dt = f(t,y).
    if flat_wind=='T'
      air_v=air_frictionv;
    else
      air_v = wall_f(p(2)); % Calculate wall velocity
    end
    rel_v = [air_v;0] - p(3:4);  % relative velocity vector
    rel_s = norm(rel_v);
    re = grain_diam * air_density * rel_s / air_viscosity;
    Cd = dragcoefficient(re);
    
    q(3:4) = gravity + 0.75*air_density/(grain_diam*grain_density)...
	*rel_v*rel_s*Cd;
    q(1:2)=p(3:4);
    q=q(:);
  case 'events'               % Return [value,isterminal,direction].
    q = [p(4) p(2)];
    isterminal = [1 1];
    direction = [-1 -1];
end 
