function wall_function
% solution of turbulent diffusion equation with pressure

small = 0.5; % Definition of >> 'much greater than'

% symmetrix solution du/dx=0 at x=x1
b = 0.01;
n = 1000;
x=linspace(0,1,n)';
scale=10;
x =(tanh(scale*(x-.5))/tanh(scale/2)+1)/2; 

% variables for upper section
C1 = 0;
C2 = C1-3 + 3* log(2)-log(b);
C3 = C2+b;
r1  = find(x<small);
r2  = find(small*x>b & small*(1-x)>0*b^2);
r3  = find((1-x)<small);
x1 = x(r1);
x2 = x(r2);
x3 = x(r3);

nr3 = find((1-x)>small);
f = NaN*zeros(n,3);
f(r1,1) = C1 + f1(x1,b);
f(r2,2) = C2 + f2(x2,b);
f(r3,3) = C3 + f3(x3,b);
plot(f);
legend('1','2','3');

function f=f1(y,b)
f = -y./(sqrt(b^2+y.^2)+b)+(1+3/16*b^2)*asinh(y/b)-...
    1/2*sqrt(b^2+y.^2)-1/16*y.*(y.^2+3*b^2)./(sqrt(b^2+y.^2));

function f=f2(y,b)
f = 2*sqrt(1-y)-(2+3/8*b^2)*atanh(sqrt(1-y))+...
    b./y-1/8*b^2*sqrt(1-y).*(2+3*y)./(y.^2);

function f=f3(y,b)
f = -2/3*(b^2+1-y).^(3/2)+b*(1-y);
%f = -2/3*(b^2+1-y).^(3/2)+b*(1-y).*(2-y)-2/5*(1-y).^2.*sqrt(b^2+1-y);


