      SUBROUTINE EJCT(dm,theta,v,a,ks,daught,alive,tim)
!********************************************************************
!     alive =0 for death of Mother; THEN spl(.,1) is freed for first
!                                                        daughter.
!     returns daught, the number of ALL ejected particles
!     (including the bouncing Mother, if not dead)
!********************************************************************
      INCLUDE 'params.inc'
      INCLUDE 'pars.inc'
      INCLUDE 'particle.inc'
      INCLUDE 'gammas.inc'
      INCLUDE 'splsh.inc'
      INCLUDE 'statist.inc'
      INCLUDE 'timing.inc'
      REAL fac,psize

      PARAMETER (fac=180./pi)

      REAL dmm,smax,smin,sumvn,sum,size,theta    
      REAL dm
      REAL randm,g,an,vn,v,a, tim
      INTEGER i,daught,nmax,nmin,n1,ks
      INTEGER alive
      DIMENSION g(numspl),an(numspl+1),vn(numspl+1)
      EXTERNAL randm
!      EXTERNAL psize

      dmm=1.e8*dm   !c...  in [mg*cm/s]:
      nmax=0
      nmin=0
 2    e9IF (dmm.gt.0. .and. dmm.lt.10.) THEN
        nmax=nint(0.7*dmm)
      ELSE IF (dmm.ge.10. .and. dmm.lt.25.) THEN
        nmax=7
      ELSE IF (dmm.ge.25.) THEN
        nmax=7
        nmin=nint(0.7*(dmm-25.0))
      ENDIF
      smax=0.
      smin=0.
      IF (dmm.gt.0. .and. dmm.lt.18.) THEN
        smax=20.*dmm
      ELSE IF (dmm.ge.18. .and. dmm.lt.25.) THEN
        smax=360.
      ELSE IF (dmm.ge.25.) THEN
        smax=360.
        smin=20.*(dmm-25.)
      ENDIF

      sumvn=smin+(smax-smin)*randm()
      daught=nint(nmin+(nmax-nmin)*randm())
      daught=max(1,daught)
      daught=min(numspl,daught)

      sum=0.
      DO i=1,daught
        n1=1+nint((nsplsh-1)*randm())
        g(i)=gamma(n1)
        sum=sum+g(i)
      ENDDO
!
!---- set up daughters
      DO i=1,daught
        vn(i)=sumvn*g(i)/sum
        n1=1+nint((nsplsh-1)*randm())
        an(i)=(125.-vn(i))*gamma(n1)+theta*fac
      ENDDO
!
!...  spl(1) is Mother, spl(2..daught) are up to numspl daughters
!     create daughters: alive=0 if Mother died in SPLASH
!                       alive=1 if Mother bounces
      spl(1).vel.x=v*cos(a)
      spl(1).vel.y=v*sin(a)
      spl(1).acc.x=0.
      spl(1).acc.y=0.

      DO i=1+alive,daught+alive
        spl(i).pos.x=spl(1).pos.x
        spl(i).pos.y=spl(1).pos.y
        spl(i).vel.x=0.01*(vn(i-alive)*cos(an(i)/fac))
        spl(i).vel.y=0.01*(vn(i-alive)*sin(an(i)/fac))
        spl(i).acc.x=0.
        spl(i).acc.y=0.
        spl(i).el_time=tim
        spl(i).diam=grnsz(1+nint(100.*randm())/34)   ! one of the 3
      ENDDO
      END
