      subroutine ejct(dm,theta,v,a,ks,daught,alive,tim)
!********************************************************************
!     alive =0 for death of mother; then spl(.,1) is freed for first
!                                                        daughter.
!     returns daught, the number of all ejected particles
!     (including the bouncing mother, if not dead)
!********************************************************************
      use params
      use pars
      use particle
      use gammas
      use splsh
      use statist
      use timing
      real(r_kind) fac

      parameter (fac=180./pi)

      !real(r_kind) size,psize
      integer ks
     real(r_kind) dmm,smax,smin,sumvn,sum,theta    
      real(r_kind) dm
      real(r_kind) randm,g,an,vn,v,a, tim
      integer i,daught,nmax,nmin,n1
      integer alive
      dimension g(numspl),an(numspl+1),vn(numspl+1)
      external randm
!      external psize

      dmm=1.e8*dm   !c...  in [mg*cm/s]:
      nmax=0
      nmin=0
      if (dmm>0. .and. dmm<10.) then
        nmax=nint(0.7*dmm)
      else if (dmm>=10. .and. dmm<25.) then
        nmax=7
      else if (dmm>=25.) then
        nmax=7
        nmin=nint(0.7*(dmm-25.0))
      endif
      smax=0.
      smin=0.
      if (dmm>0. .and. dmm<18.) then
        smax=20.*dmm
      else if (dmm>=18. .and. dmm<25.) then
        smax=360.
      else if (dmm>=25.) then
        smax=360.
        smin=20.*(dmm-25.)
      endif

      sumvn=smin+(smax-smin)*randm()
      daught=nint(nmin+(nmax-nmin)*randm())
      daught=max(1,daught)
      daught=min(numspl,daught)

      sum=0.
      do i=1,daught
        n1=1+nint((nsplsh-1)*randm())
        g(i)=gamma(n1)
        sum=sum+g(i)
      enddo
!
!---- set up daughters
      do i=1,daught
        vn(i)=sumvn*g(i)/sum
        n1=1+nint((nsplsh-1)*randm())
        an(i)=(125.-vn(i))*gamma(n1)+theta*fac
      enddo
!
!...  spl(1) is mother, spl(2..daught) are up to numspl daughters
!     create daughters: alive=0 if mother died in splash
!                       alive=1 if mother bounces
      spl(1)%vel%x=v*cos(a)
      spl(1)%vel%y=v*sin(a)
      spl(1)%acc%x=0.
      spl(1)%acc%y=0.

      do i=1+alive,daught+alive
        spl(i)%pos%x=spl(1)%pos%x
        spl(i)%pos%y=spl(1)%pos%y
        spl(i)%vel%x=0.01*(vn(i-alive)*cos(an(i)/fac))
        spl(i)%vel%y=0.01*(vn(i-alive)*sin(an(i)/fac))
        spl(i)%acc%x=0.
        spl(i)%acc%y=0.
        spl(i)%el_time=tim
        spl(i)%diam=grnsz(1+nint(100.*randm())/34)   ! one of the 3
      enddo
      end
