      INTEGER FUNCTION ENTRAN(dtau)
!
!     Paper by Nickling: Entfac is Number per width and time and stress
!                                  unit : s/kg
!           No of grains is per time and width!  Same here, but I need
!           bedlength as well for model.
!
      INCLUDE 'params.inc'
      INCLUDE 'pars.inc'
      INCLUDE 'particle.inc'
      INCLUDE 'ichan.inc'
 
      REAL entfac
      COMMON /entr/ entfac
      REAL dtau,raero, randm, R
!      REAL stdev,gauss
!
!     for the Poisson process:
      INTEGER trigger,k, factorial
      PARAMETER (trigger=3)
      REAL N_t
      PARAMETER (N_t = trigger)
      REAL poisson, poisstime, numerator, A
      DIMENSION poisson(0:trigger)
 
      EXTERNAL factorial, randm
    
      A=Entfac*bedlen*bedwid*dtau
     
      raero=A*tstep
      raero=max(raero,0.)
!      write(*,*) dtau, raero
!...  standard deviation as function of aero:
!      stdev=2./75.*raero
!...  Normal distributed REAL number
!      gauss=stdev*(cos(2.*pi*randm())*sqrt(-2.*log(randm())))
!      entran=nint(raero+gauss)
!                               N/l/dt
!          start a Poisson process if time step too small but Tau large enough
!
      IF (raero .lt. N_t .and. A.gt. poissa) THEN
        poisstime=poisstime+tstep      ! start with a time step
        numerator=poisstime*A
        R=randm()
        Poisson(0)=0.
        DO k=1,trigger
          Poisson(k)=Poisson(k-1)+numerator**k/factorial(k)*exp(-numerator)
        ENDDO
        entran=0
        DO k=1,trigger
          IF (R .le. Poisson(k)) THEN
!           write(iclog,'(4(e11.4,1x))') dtau,poisstime,Poisson(k),numerator
             poisstime=0.
             entran=k
             EXIT
          ENDIF
        ENDDO
      ELSE   
        entran=nint(raero)
        entran=min(entran,NGRAINS/4)
        poisstime=0. 
      ENDIF

      END
