module entrainment
  use params
  use pars
  use particle
contains
  function entran(dtau,entfac)
    integer entran
    !
    !     paper by nickling: entfac is number per width and time and stress
    !                                  unit : s/kg
    !           no of grains is per time and width!  same here, but i need
    !           bedlength as well for model.
    !
    real(r_kind),intent(in) :: dtau,entfac

    real(r_kind) raero, randm, r
    !      real(r_kind) stdev,gauss
    !
    !     for the poisson process:
    integer trigger,k, factorial
    parameter (trigger=3)
    real(r_kind) n_t
    parameter (n_t = trigger)
    real(r_kind) poisson, poisstime, numerator, a
    dimension poisson(0:trigger)

    external factorial, randm

    a=entfac*bedlen*bedwid*dtau

    raero=a*tstep
    raero=max(raero,real(0.,r_kind))
    !      write(*,*) dtau, raero
    !...  standard deviation as function of aero:
    !      stdev=2./75.*raero
    !...  normal distributed real(r_kind) number
    !      gauss=stdev*(cos(2.*pi*randm())*sqrt(-2.*log(randm())))
    !      entran=nint(raero+gauss)
    !                               n/l/dt
    !          start a poisson process if time step too small but tau large enough
    !
    if (raero < n_t .and. a> poissa) then
       poisstime=poisstime+tstep      ! start with a time step
       numerator=poisstime*a
       r=randm()
       poisson(0)=0.
       do k=1,trigger
          poisson(k)=poisson(k-1)+numerator**k/factorial(k)*exp(-numerator)
       enddo
       entran=0
       do k=1,trigger
          if (r <= poisson(k)) then
             !           write(iclog,'(4(e11.4,1x))') dtau,poisstime,poisson(k),numerator
             poisstime=0.
             entran=k
             exit
          endif
       enddo
    else   
       entran=nint(raero)
       entran=min(entran,ngrains/4)
       poisstime=0. 
    endif
  end function entran
end module entrainment

