      SUBROUTINE LACALC(aero,lost,total,test,scr,sample)
!******************************************************************
!     per 'wind time step' this routine tracks all particles
!     simultaneously (try running this on CM in Edinburgh!!)
!******************************************************************
      INCLUDE 'params.inc'
      INCLUDE 'pars.inc'
      INCLUDE 'particle.inc'
      INCLUDE 'timing.inc'
      INCLUDE 'ichan.inc'
      INCLUDE 'pszdstr.inc'
      INCLUDE 'splashmod.inc'
      INCLUDE 'splsh.inc'
      INCLUDE 'averag.inc'
      INCLUDE 'discrete.inc'
      INCLUDE 'strecom.inc'
      INCLUDE 'tracom.inc'

 
      INTEGER i,j,lost,track_lost, aero, losthere,ig,total
      REAL randm,stddev,uv,vv
      EXTERNAL randm
      LOGICAL sample, test,scr

      DO j=1,NYMAX
        dmom(j).x=0.        ! x momentum exchange (source) in each CV
        dmom(j).y=0.        ! y momentum exchange in each CV
        dtmflx(j)=0.        ! total momentum of all grains per CV
        conc(j)=0.
        pvol(j)=0.
        rnumb(j)=0.
        dflux(j)=0.        ! Rugby Count
        vflux(j)=0.
        number(j)=0
        Anzahl(j)=0         ! for AVERAG/WRITING (sampling over certain time)
        Konz(j)=0.          !                     dito
      ENDDO
      tmflx=0.              ! Total Mass Flux (integral of dtmflx)
      Impacts=0             ! zeroed before time step is calculated
      Daughters=0
      Deads=0
      Ejecta=0
      lost=0
      av.v_in=0.
      av.v_out=0.
      av.a_in=0.
      av.a_out=0.
!
!---  'comb' the list (fill the wholes)
!
      i=0
      j=NGRAINS
      DO
!        write(*,*) i, '   ', j
        IF (grain(i+1).diam.eq.0. .and. grain(j).diam .ne. 0.) THEN
           grain(i+1)=grain(j)
           grain(j).diam=0.        ! free the `j' place
!           grain(j).el_time=0.
!           grain(j).pos.x=0.
!           grain(j).pos.y=0.
!           grain(j).vel.x=0.
!           grain(j).vel.y=0.
!           grain(j).acc.x=0.
!           grain(j).acc.y=0.
           i=i+1
           j=j-1
        ENDIF
        IF (grain(i+1).diam.ne.0.) i=i+1
        IF (grain(j).diam.eq.0.) j=j-1
        IF (i.ge.j) EXIT
      ENDDO
      DO ig=1,NGRAINS
        IF (grain(ig).diam.eq.0.) EXIT
        grain(ig).el_time=0.
      ENDDO                                  ! ig=NGRAINS+1 if list is full
      losthere=max(0,aero-(NGRAINS-(ig-1)))       ! then lost=aer

      total=i+aero-losthere     !  number of grains entering TRACK
!
! ===== Then place aero newly generated grains into the free slots =====
!
!     with aer=25,NGRAINS=101 the following evaluations:
!
!     ig=1    :  i=1,1+25-1-0      ==> i=1,25     (25 trips)
!     ig=101  :  i=101,101+25-1-24 ==> i=101,101  (one trip)
!     ig=99   :  i=100,100+25-1-23 ==> i=100,101  (2 trips)
!
      DO i=ig,ig+aero-1-losthere            ! generate AER grains into list

        grain(i).pos.x=bedlen*randm()  ! X-pos
        grain(i).pos.y=grid.Y(1)         ! Height (easy)
        grain(i).ij=2
!----   Trial: Log-Normal distribution for U-Velocity
!       gauss=cos(2.*pi*randm())*sqrt(-2.*log(randm()))
!       random=exp(sqrt(2.*log(1.1))*gauss)
!
!       uav   = 0.130;            { mean U }
!       u50   = 0.110;            { median value U}
!       u0    = 0.0;              { offset U }
!       vav   = 0.030;
!       v50   = 0.020;
!       v0    = 0.000;
!
        stddev=sqrt(2.*log((uav-u0)/(u50-u0)))
        uv=log(uav-u0) +stddev*sqrt(-2.*log(randm()))*cos(2.*pi*randm())
        uv=exp(uv)
        if (uv .le. 0.01*ui(2)) uv=0.
        DO j=1,nu
          IF (uv.le.ui(j)) EXIT
        ENDDO
        grain(i).vel.x=ui(j)
        if (sample) numu(j)=numu(j)+1
!
!....   and now for the V-Velocity:
        stddev=sqrt(2.*log((vav-v0)/(v50-v0)))
        vv=log(vav-v0) +stddev*sqrt(-2.*log(randm()))*cos(2.*pi*randm())
        vv=exp(vv)
        vv=max(0.001,vv)

        DO j=1,nv
            IF (vv.le.vj(j)) EXIT
        ENDDO
        grain(i).vel.y=vj(j)
        if (sample) numv(j)=numv(j)+1
!
!-----  produce the particle size in meters
!        grain(i).diam=grnsz(1+nint(100.*randm())/34) ! Geil, wa?
        grain(i).diam=grnsz(1) 
        if (sample) then
          DO j=1,Ntray
            IF (grain(i).diam .lt. 1.e-6*mesh(j)) EXIT
          ENDDO
          nums(j)=nums(j)+1
        endif

      ENDDO
      lost=lost+losthere
! =======   End of generating the grains (DO ig=...) ===================
!
!+++++ Now track ALL grains ++++
 
      IF (total.gt.0) CALL TRACK(track_lost,test,scr,sample)  ! track 'em
!     from track back: total+Born-Deads

      lost=lost+track_lost
      END
