      subroutine midair(up,vp,d)
c   adopt the notation and concepts given in sorensen
c   and mcewan (1994)
c   note that l is declared as REAL
      EXTERNAL randm
      INTEGER i
      REAL up,vp,d,r,l,randm,u,h,w,a,b,psi,v,wp,ru,xl
      INTEGER alive,born
      DIMENSION h(3),w(3),v(3)
      INCLUDE 'params.inc'
      INCLUDE 'pars.inc'
      INCLUDE 'particle.inc'
      INCLUDE 'midair.inc'
      INCLUDE 'splsh.inc'
      u=sqrt(up*up+vp*vp)
      psi=atan(-vp/up)
      r=d/2.
      ru=randm()
      i=-1
12    i=i+1
      l=2.*r*float(i)/100.
      xl=l*l/(4.*r*r)
      if(ru.gt.xl) goto 12
      b=asin(l/(2.*r))
      a=randm()*2.*pi
      h(1)=0.85*(cos(psi)*cos(b)*cos(b)+sin(psi)*cos(b)*sin(b)*sin(a))
      h(2)=0.85*(-sin(psi)*cos(b)*cos(b)+cos(psi)*cos(b)*sin(b)*sin(a))
      h(3)=0.85*cos(b)*sin(b)*cos(a) 
      w(1)=u*h(1)
      w(2)=u*h(2)
      w(3)=u*h(3) 
      v(1)=u*(cos(psi)-h(1))
      v(2)=u*(-sin(psi)-h(2))     
      v(3)=-u*h(3)
      totnmid=totnmid+1.
      spl(1).vel.x=v(1)
      spl(1).vel.y=v(2)
      spl(1).acc.x=0.
      spl(1).acc.y=0.
      alive=1
      spl(2).pos.x=spl(1).pos.x
      spl(2).pos.y=spl(1).pos.y
      spl(2).vel.x=w(1)
      spl(2).vel.y=w(2)
      spl(2).acc.x=0.
      spl(2).acc.y=0.
      born=1
      wt1=wt1+w(1)
      wt2=wt2+w(2)
      wt3=wt3+w(3)
      vt1=vt1+v(1)
      vt2=vt2+v(2)
      vt3=vt3+v(3)
      wfrac=sqrt(wt1*wt1+wt2*wt2+wt3*wt3)/(totnmid*u)
      vfrac=sqrt(vt1*vt1+vt2*vt2+vt3*vt3)/(totnmid*u)
      wp=0.0
      write(6,*) 'MIDAIR COLLISION !!!',totnmid
      write(6,*) v(1),v(2),v(3)
      write(6,*) w(1),w(2),w(3)
      write(6,*) vfrac,wfrac,vfrac+wfrac
      return
      end
