! Function for opening data files for random access
module opfi2
  use sysdep_io
contains
  ! Creates a file for writing records of length reclen or
  ! or opens it if it already exists
  ! returns the number of the last record
  ! The first position is uesed to store the number of records
  function opfi2_write(fname,unit,reclen,format,new) result(position)
    character(len=*),intent(in) :: fname   ! Filename to open
    integer,intent(in) :: reclen           ! record length
    integer,intent(in) :: unit             ! unit number to open with
    character(len=*),intent(in) :: format  ! 'unformatted' or 'formatted'
    logical,intent(out), optional :: new             ! New file has been created ?
 
    integer position

    logical fex, fopen

    inquire(file=fname,exist=fex)
    if ( .not. fex) then  
       write(std_out,*)'file ', fname, ' nonexistent. Creating'
       open(unit,file=fname,access='direct',recl=reclen,form=format,status='new')
       position=1
       if (present(new))  new= .true. 
       if (format=='unformatted') write(unit,rec=1) position
    else
       open(unit,file=fname,access='direct',recl=reclen,form=format,status='old')
       if (present(new)) new= .false. 
       if (format=='unformatted') read(unit,rec=1) position
    endif
  end function opfi2_write
end module opfi2
