SUBROUTINE READING(casefil,read3,write3,history,profs& 
           ,test,scrout,filin,filout)
!****************************************************************
!     read in input parameters
!****************************************************************
      INCLUDE 'params.inc'
      INCLUDE 'pars.inc'
      INCLUDE 'particle.inc'
      INCLUDE 'ucalc.inc'
      INCLUDE 'discrete.inc'
      INCLUDE 'ichan.inc'
      INCLUDE 'splsh.inc'
      INCLUDE 'ricochmod.inc'
      INCLUDE 'gammas.inc'
      INCLUDE 'ufluct.inc'
      INCLUDE 'timing.inc' 
      INCLUDE 'pszdstr.inc'
      INCLUDE 'outdirmod.inc'
      use sysdep_io

      REAL sstt,totmass,totprob
      REAL entfac, gravity
      REAL dummy(nymax)
      COMMON /entr/ entfac
      COMMON /sampling/ samsta,samend
      INTEGER i,j,ndum
      INTEGER samsta,samend
      INTEGER Nmeas
      INTEGER itest(5)
      COMMON /testgrain/ itest
      LOGICAL read3,write3,history,profs,onesize,test,scrout
      CHARACTER(len=*) filin,filout,casefil
      CHARACTER*20 velocin
      integer temp_fp
      integer icsalt,icgam,icvel,icsur
      
 call assign_lun(icsalt) 
 call assign_lun(icgam)
      call assign_lun(icvel)
      call assign_lun(icsur)
 
      IF (casefil .eq. ' ') THEN
        write(std_out,'(1x,a)') ' Enter input file name'
        read(*,'(a)') casefil
      ENDIF
      write(std_out,'(1x,2a)') ' opening input file ',casefil
      OPEN(icsalt,file=casefil,status='old')
!
!---- the task:
      read(icsalt,*) numiter
      read(icsalt,*) samsta,samend
      read(icsalt,*) tstep,sstt
      read(icsalt,*) histout, profout
!
!---- switches
      read(icsalt,*) onesize, history, profs, test, scrout
      read(icsalt,*) (itest(i),i=1,5)
      read(icsalt,*) read3, filin
      read(icsalt,*) write3, filout
      read(icsalt,*) type,ubase,uend, itstatio
      read(icsalt,*) ampli,period,maxit,eps,dudymin
      read(icsalt,*) press, mixf, urf
!---- output specs
      read(icsalt,*) OUTDIR,velocin
      Laenge=0
      DO   
        Laenge=Laenge+1
        IF (OUTDIR(Laenge:Laenge).eq.' ') EXIT
      ENDDO
      OUTDIR(Laenge:Laenge)='/'
      write(*,*) ' Output directory is:',OUTDIR(1:Laenge),' !'
!
!---- the environment (fluid and constant of gravity )
      read(icsalt,*) fdens, visco, gravity
      Gravit.x=0.
      Gravit.y=gravity
!
!---- The bed
      read(icsalt,*) bedlen, bedwid, xprof, slope
!
!+++++ The GRAINS:
!----- bed impact specs
      read(icsalt,*) succsalt,plife
!
!---- saltation experiments (define the sand bed)
      read(icsalt,*) tauthres,entfac,poissa,yzero
!---- grains density and sizes
      read(icsalt,*) grain_dens
      read(icsalt,*) (grnsz(i),i=1,NSZ)
      DO i=1,NSZ
         grnsz(i)=1.e-6*grnsz(i)
      ENDDO
!---- entrained grains' velocities
      read(icsalt,*) uav,u50,u0,vav,v50,v0
!
!---- Sand characteristics:
      read(icsalt,*)  Nmeas
      mesh(0)=0.
      DO i=1,Nmeas
        read(icsalt,*) mesh(i),cumul(i)
      ENDDO
      CLOSE(icsalt)
!.... initial wind profile:
      write(std_out,'(2x,2a)') casefil,' closed.'
      if (.not.read3) then
         call assign_lun(temp_fp)
         write(std_out,'(14x,2a)')  '... now opening ',velocin
         open(temp_fp,file=velocin,form='unformatted',status='old')
         read(temp_fp) dummy,tau
         close(temp_fp)
         write(std_out,'(2x,2a)') velocin,' closed.'
         do j=1,nymax
            fluid.u(j)=dummy(j)
         enddo
      endif

      write(std_out,'(1x,a)') ' Opening GRID.BIN...'
      call assign_lun(temp_fp)
      open(temp_fp,file='grid.bin',form='unformatted',status='unknown')
      read(temp_fp) ndum
      read(temp_fp) (grid.Y(j),j=1,ndum)
      read(temp_fp) (grid.fy(j),j=1,ndum)
      CLOSE(temp_fp)
      write(std_out,*) ' Grid file read. Opening velo_in'
      IF (ndum.ne.nymax) THEN
        write(*,'(1X,a,/,1X,a)')& 
     'Grid size <> NYMAX! Problems will occur in subroutine CALCU.',& 
      'Set NYMAX to the appropriate value in PARAMS.INC and recompile.'
       STOP
      ENDIF

      vkarman=0.41
!
!---- Read in parameters from file(s)
!
      OPEN(icvel,file='velo_in',status='old')
      read(icvel,*) (ui(i),i=1,nu)
      read(icvel,*) (vj(i),i=1,nv)
      CLOSE(icvel)
      write(std_out,*) ' velo_in closed. Reading gamma.bin'
 
      OPEN(icgam,file='gamma.bin',status='old',form='unformatted')
      read(icgam) (gamma(i),i=1,nsplsh)
      CLOSE(icgam)
      write(std_out,*)' gamma.bin closed. Reading sur.bin'

      area=bedlen*bedwid
      vol(1)=0.
      DO j=2,njm
         vol(j)=area*(grid.Y(j)-grid.Y(j-1))
         airmss(j)=vol(j)*fdens
      ENDDO
      vol(nj)=0.

!      DO i=1,nsz
!         grnvol(i)=pi/6.*grnsz(i)**3
!         grnmss(i)=grndens*grnvol(i)
!      ENDDO
!      totmass=grnmss(1)+grnmss(2)+grnmss(3)
!      totprob=totmass*(1./grnmss(1)+1./grnmss(2)+1./grnmss(3))
!      ep1=totmass/(grnmss(1)*totprob)
!      ep2=totmass/(grnmss(2)*totprob)+ep1
!      ep3=totmass/(grnmss(3)*totprob)+ep2
!      IF (onesize) THEN
!        ep1=0.0
!        ep2=1.0
!        ep3=1.0
!      ENDIF
!
!---- depending on the order of input data in 'SUR.BIN' change these
!            if necessary:
      OPEN(icsur,file='sur.bin',form='unformatted')
      hmax=-100.0
      DO i=0,nix-1
        read(icsur,end=20) sur(i+1).x, sur(i+1).y, sur(i+1).d
        IF (sur(i+1).y .gt. hmax) hmax=sur(i+1).y
      ENDDO

  20  i=min(i,nix)
      write(std_out,'(1X,a,i6,a)') ' End of file in: sur.bin! ('&  
                            ,i,' records read)'
      hmax=hmax+1.0
      CLOSE(icsur)

      deltat=sstt*tstep
!
!---- for batch listing:
      write(*,'(//1x,a)')    ' This run with...'
      write(std_out,101) &
            ' Iterations:',numiter &
           ,' Samples from ',samsta,' to ',samend &
           ,' succsalt  :',succsalt,'      plife:',plife &
           ,' bedlength :',bedlen,'  Bedwidth :',bedwid &
           ,' Entfac    :',entfac,'   Profile :',xprof &
           ,' base time :',tstep, 's  base/dt :',1./sstt &
           ,' dt_0      :',deltat,'s  bed slop:',slope 
!     &     ,' epsilon   :',ep1,ep2,ep3
      IF (history) write(std_out,102)&
           ' Time logging every ',histout,' Iterations (F)'
      IF (profs) write(std_out,102)&
           ' Writing Prof every ',profout,' Iterations (P)'
      Write(std_out,'(1x,2(a,L1))') &
         ' Read in: ',read3,' Write out: ',write3
      write(std_out,111)
!      write(*,*)
!      write(*,'(1x,a)') '        Hit return'
!      read(*,*)

  101 FORMAT(1x,a12,i12,/1x,2(a,i5),& 
          /5(1x,2(a12,e12.5),:,/)& 
!     &      /1x,a12,3(f4.1,:,', ')    ! that's for the ep1, ep2, ...
            )
  102 FORMAT(1x,a,i2,a)
  111 FORMAT(2x,50('_'))
 
      RETURN
      END
