      PROGRAM saltare !(casefil)
!
!     Unsteady Winds !  Now trying to write a 'true' parabolic code
!     and trajectory halt.
!
      use params
      use pars
      use particle
      use timing
      use discrete    ! Only for U(2) and T(2)
      use tracom
      use ichan
      use splashmod
      use outdirmod

      INTEGER :: i,aero, itold
      type zeit    ! german word for `time'
         integer ::  hour, minute, second, hundredth
         end type
      type(zeit) :: tstart, tend

      type Datum    ! german word for `date'
         INTEGER year, month, day
      end type
      type(Datum) :: dstart, dend

      INTEGER lost,entran,j,all,old_all
      INTEGER rcwind,samsta,samend
      COMMON /sampling/ samsta,samend
      INTEGER channel(2)

      REAL  rvol,randm,sp,gstr,dfl,con,numb, old_tim, time

      LOGICAL history, profs, test, read3, write3, scr, ex
      LOGICAL fileda, sample, fstwrt, fstprof, newpro, joblog, scr1
      DATA joblog/.false./
      INTEGER totent
      EXTERNAL fileda, randm, entran
      DIMENSION sp(nymax),gstr(nymax),dfl(nymax),con(nymax),numb(nymax)

      CHARACTER(LEN=12)  filout, filin, profile
      CHARACTER(LEN=20) casefil, comline
      CHARACTER(LEN=1) char

      !IF (casefil.ne.' ') 
      joblog=.false.
      scr1=.not.joblog
      CALL systime(dstart.year,dstart.month,dstart.day &
                ,tstart.hour,tstart.minute,tstart.second,tstart.hundredth)
      icout=6
      icin=5
      icprof=33
      iclog=44
      icpj=88

      channel(1)=icout
      channel(2)=iclog
      open(iclog,file='salt5.log')
!      open(icpj,file='pj.dat')
!      open(551,file='track1.dat')
!      open(552,file='track2.dat')
!      open(553,file='track3.dat')
!      open(554,file='track4.dat')
!      open(555,file='track5.dat')
      profile='profil.bin'  ! channel NO. 31 (icprof)

      totent=0
      lost=0
      write(icout,*)
      write(icout,'(///,5(15x,a,/),/)')   & ! here's the title
             '                SALT 5.01 ' &
            ,' Grain Size Distribution, unsteady Winds' &
            ,'          Peter-J. Spies 1994' &
            ,' ---------------------------------------' &
            ,' beta version for 2D tests, new logicals'

!---- read in parameters
      CALL READING(casefil,read3,write3,history,profs,test,scr,filin,filout)

      IF (read3) THEN
         DO i=1,12
            IF (filin(i:i) .eq. ' ') EXIT
         ENDDO
         ex=fileda(filin(1:i-1))          ! instead of inquire

         IF (.not.ex) THEN
            write(*,'(1x,3a)') ' ',filin(1:i-1),' does not exist!'
            write(*,'(1x,a/1x,a,a/)')&
               ' Type (''N'') for a NEW program run and file...'&
             ,' other to enter different *.RES file of older run'&
             ,' (must exist!).'
            read(*,'(a1)') char
!           char='N'                !   for DEBUG (and background run)
            IF (char.eq.'N' .or. char.eq.'n') THEN
               read3=.false.
            ELSE
!----          BREAK-IF (99/98) construct to get input file
               DO
                 write(*,'(a/1x)') ' Enter file name for results '
                 read(*,'(a)') filin
                 inquire(file=filin,exist=ex)
                 IF (ex) EXIT
                 write(*,*) ' ****  file not found  ****'
               ENDDO
            ENDIF
         ENDIF                 !...    .not.ex

         OPEN(3,file=filin,form='unformatted',status='old')
         write(*,*) '  reading in old results - please wait'
         read(3) itold,old_tim,old_all
         read(3) fluid,grain
         close(3)
      ELSE
         CALL INIT
         itold=0
         old_tim=0.
      ENDIF
      fstwrt  = .not.read3       ! for wrtout-files
      fstprof = .not.read3       ! for profil.bin

      iter=itold
      time=old_tim
      IF (profs) THEN
         write(icout,'(1x,2a)')& 
           ' Writing profiles into file ',OUTDIR(1:Laenge)//profile
         CALL opfi2(OUTDIR(1:Laenge)//profile,icprof,'UNFORMATTED' &
                  ,8*(2+7*nj),rcwind,fstprof,newpro)
         fstprof=.false.
         IF (.not.newpro) THEN
             read(icprof,rec=1) rcwind
         ELSE
!            write(icprof,rec=1) rcwind   write only if formatted.
!...         only if BRAND NEW START write initial profiles
             IF (iter.eq.0)  THEN
                rcwind=rcwind+1
                write(icprof,rec=rcwind) iter,time & 
                           ,fluid.U,tau,sp,gstr,dfl,con,numb
                write(icprof,rec=1) rcwind
             ENDIF
         ENDIF
         CLOSE(icprof)
      ENDIF
      write(icout,'(1x,a,3(i5,a),2(f6.3,a))') & 
      ' ->',numiter,' iterations start now; from ',itold+1,' to '& 
        ,itold+numiter,'  times: ',time,' to ',(numiter+itold)*tstep,' s'
      IF (.not.read3)& 
           write(*,102) 'I',iter,' t',time  &              ! first display
          ,' O',old_all,' E',aero,' G',all & 
         ,' B',Daughters,' D',Deads & 
!          ,' L',lost & 
           ,' t2',tau(2) & 
          ,' U2',fluid.U(2) & 
         ,' Q',tmflx/area
!
!+++++++++++ The time iterations start here ++++++++++++
      DO iter=itold+1,numiter+itold
         time=time+tstep
         CALL CALCU(time,tau,sp,gstr,test) ! Calculate the Wind
                                                            !  Velocity
         sample=iter.ge.samsta .and. iter.le.samend  ! sample is boolean
         aero=ENTRAN(abs(tau(2))-tauthres)       !  Aerodynamic Entrainment:
!
!---     Trajectory Calculations (the discrete phase bit)
         CALL LACALC(aero,lost,all,test,scr1,sample) ! LAgrangian CALCulation

         IF (scr .or. joblog)  THEN          ! screen ouput if needed:
              DO i=1,2
                  write(channel(i),102) 'I',iter,' t',time&
                 ,' O',old_all,' E',aero,' G',all&
                  ,' B',Daughters,' D',Deads&
!                  ,' L',lost&
                  ,' t2',tau(2)&
                  ,' U2',fluid.U(2)&
                  ,' Q',tmflx/area
              ENDDO
         ENDIF

         old_all=all+Daughters-Deads
         IF (sample) CALL calc_average
         IF (profs .and. mod(iter,profout).eq.0) THEN ! Write profiles if asked for:
                dfl(1)=dtmflx(1)/area          ! differential flux
                numb(1)=rnumb(1)/area          ! Number of P.s in CV
                con(1)=conc(1)/(area)          ! Concentration
                DO j=2,nymax-1
                     rvol=area*(grid.Y(j)-grid.Y(j-1))
                     dfl(j)=dtmflx(j)/rvol
                     numb(j)=rnumb(j)/rvol
!-----               mass load:
                     con(j)=conc(j)/(10**(-30)+fdens*(rvol-pvol(j)))
                ENDDO
                dfl(nymax)=dtmflx(nymax)/area
                numb(nymax)=rnumb(nymax)/area
                con(nymax)=conc(nymax)/(fdens*area)

                CALL opfi2(OUTDIR(1:Laenge)//profile,icprof,'UNFORMATTED'&
                    ,8*(2+7*nj),rcwind,.false.,newpro) ! do not overwrite
                IF (.not.newpro) THEN
                     rcwind=rcwind+1
                     write(icprof,rec=rcwind)&
                        iter,time,fluid.U,tau,sp,gstr,dfl,con,numb
                     write(icprof,rec=1) rcwind
                     IF (scr1 .or. test) write(*,*) '[24;2H[36mP[0m'
                ELSE
                      write(*,*) ' OOPS! Was''n das''n ? - No1'
                ENDIF
                CLOSE(icprof)  ! for security: save the file, once written.
         ENDIF
                                                        ! ######
         IF (history .and. ( mod(iter-itold,histout).eq.0 .or.& !# write out
                           iter-itold.eq.numiter) ) THEN      !# time
             CALL WRTOUT(iter,aero,all,fstwrt,scr1)           !# tracking
             fstwrt=.false.                                   !# every histout
         ENDIF                                                !# iterations

      ENDDO             ! END OF TIME ITERATIONS
!
      CALL systime(dend.year,dend.month,dend.day& 
                ,tend.hour,tend.minute,tend.second,tend.hundredth)
      write(icout,*) '    Iterations done. Starting output process.'
!
!---- Store temporarilly  (HUGE FILE !!!!!)
      IF (write3) THEN
         write(icout,'(a,a)') ' Storing results in ',filout
         itold=itold+numiter
         OPEN(3,file=filout,form='unformatted')
         write(3) itold,time,old_all
         write(3) fluid,grain
         close(3)
      ENDIF
      CALL writing
      write(icout,*) '[1;31m   --- Program ends ---[0m'
      write(icout,'(a13,2(i2,a1),i4)')& 
         ' start date: ',dstart.day,'/',dstart.month,'/',dstart.year
      write(icout,100)& 
       ' start time: ',tstart.hour,tstart.minute,tstart.second
      write(icout,'(a13,2(i2,a1),i4)')& 
         '   end date: ',dend.day,'/',dend.month,'/',dend.year
      write(icout,100)& 
       '   end time: ',tend.hour,tend.minute,tend.second
!
!---- Formats and file handling
!
  100 FORMAT(a,3(i2,:,':'))
  102 format(1x,a,i5,a,1pe10.3,1(a,i5),1(a,i3),1(a,i5),2(a,i3)& 
           ,1(a,0Pe10.3),1(a,f5.2),1(a,f7.4))

      CLOSE(iclog)
!      CLOSE(icpj)
!      CLOSE(551)
!      CLOSE(552)
!      CLOSE(553)
!      CLOSE(554)
!      CLOSE(555)

      STOP
      END
