      SUBROUTINE SPLASH(ks,eject,alive,daught)
                                !******************************************************************
                                !      input:
                                !            KS      size category of particle
                                !     output:
                                !            DAUGHT  Number of daughter particles
                                !            ALIVE   Number of Mother particles {0,1}
                                !            EJECT   Mother plus Daughter(s)
                                !     spl(1) is Mother if alive, spl(2..numspl+1) are Daughters
                                !     spl is of STRUCTURE /particle/
                                !******************************************************************
      INCLUDE 'params.inc'
      INCLUDE 'pars.inc'
      INCLUDE 'particle.inc'
      INCLUDE 'splsh.inc'
      INCLUDE 'timing.inc'
      INCLUDE 'tracom.inc'

      REAL ai,a1,v1,v3,a3,delvx,xp,rp,theta,dxmom
      REAL randm
      EXTERNAL randm
      REAL xf, pb

      INTEGER daught,alive,eject,ks,samsta,samend
      LOGICAL noeje
      COMMON /sampling/ samsta,samend

      theta=slope*(pi/180.)
      v1=sqrt(spl(1).vel.x**2+spl(1).vel.y**2)
      a1=atan(spl(1).vel.y/spl(1).vel.x)

      noeje=.false.
      ai=a1
      xp=spl(1).pos.x
      rp=0.5*spl(1).diam
      IF (a1 .lt. 0.) THEN
         CALL RICOCH(xp,rp,v1,a1,v3,a3) 
                                !      write(*,*) v1,a1*57.3,v3,a3*57.3
                                !      a3=0.5
                                !      v3=0.6*v1
                                !     angle in rads
                                !---  in [m/s]:
         delvx=(spl(1).vel.x-v3*cos(a3))
                                !---  in [kg*m/s]
         dxmom=(4./3.)*pi*grain_dens*delvx*rp*rp*rp
         
                                !      succsalt=1.
         IF (randm().lt.succsalt) THEN
            spl(1).vel.x=v3*cos(a3) !....   Mother bounces
            spl(1).vel.y=v3*sin(a3)
            spl(1).acc.x=0.
            spl(1).acc.y=0.
            alive=1
         ELSE
                                !....   Mother dies, DAUGHT daughters will live
            alive=0
         ENDIF
         
         IF (delvx .lt. 2.1) THEN
            xf=delvx/2.1
            pb=xf*plife
            IF (pb .lt. randm()) THEN
               daught=0
               noeje=.true.
            ENDIF
         ENDIF

      ELSE                      ! no V-vel...
         v3=0.
         a3=0.
         alive=0
         daught=0
         noeje=.true.
      ENDIF
      IF (.not.noeje) THEN
         CALL EJCT(dxmom,theta,v3,a3,ks,daught,alive,spl(1).el_time)
      ENDIF
      eject=daught+alive
                                !
                                !---  Averaging splash values (ns counts, ouput in writing)
      IF (iter.ge.samsta .and. iter.le.samend) THEN
         bonc_aver(ks).v_in =bonc_aver(ks).v_in +v1
         bonc_aver(ks).v_out=bonc_aver(ks).v_out+v3
         bonc_aver(ks).a_in= bonc_aver(ks).a_in +ai
         bonc_aver(ks).a_out=bonc_aver(ks).a_out+a3
         neject(ks)=neject(ks)+daught
         ns(ks)=ns(ks)+1
      ENDIF
      IF (alive.eq.1) THEN
         av.v_in =av.v_in +v1
         av.v_out=av.v_out+v3
         av.a_in =av.a_in +ai   ! or ai ????
         av.a_out=av.a_out+v3
      ENDIF

      RETURN
      END
