      SUBROUTINE track(lost,test,scr,sample)
!
      INCLUDE 'params.inc'            ! defines structure vector
      INCLUDE 'pars.inc'              ! defines 2D-vector `Gravit'
      INCLUDE 'particle.inc'
      INCLUDE 'discrete.inc'
      INCLUDE 'strecom.inc'           ! defines 2D-vector `dmom'
      INCLUDE 'averag.inc'           
      INCLUDE 'timing.inc'
      INCLUDE 'tracom.inc'
      INCLUDE 'splsh.inc'
      INCLUDE 'splashmod.inc'
      INCLUDE 'statist.inc'
      INCLUDE 'ichan.inc'
      INCLUDE 'midairmod.inc'

      REAL fac1, fac, cd,re, urel_mag
      REAL ff,ffp, fa, yp, yn, ys
      REAL dt, grain_mass, grain_vol
      REAL pcoll,rvol,randm,urx,ury,vtx,vty
      INTEGER collis_count, igdel

      CHARACTER W(4)
      DATA W/'|','/','-','\'/
!-----------------------  for tests only ---------------------------
       INTEGER itest(5), icht(5), icheck
       REAL testim(5)
       logical logtest
       COMMON /testgrain/ itest
       data icht /551,552,553,554,555/
!-------------------------------------------------------------------

      RECORD /vector/ Urel, Uint, Pold, Uold, mom, add_pres, uoint
      EXTERNAL cd,randm

      INTEGER j,jnew,jold,ig,z, i
      INTEGER alive, born, ejected, grain_class, lost
      LOGICAL impfl, time_up, sample, test, scr, flxlgd,midafl

!      DATA Uint.y,uoint.y /0.,0./   ! Uint.y=0 because V_f=0
       ! DATA for records not possible on HP ?

      REAL UO
      DIMENSION UO(NJ)
      COMMON /added_mass/ UO

      logtest=.false.
      collis_count = 0
      ig=0
      Uint.y=0.
      Uoint.y=0.
      IF (test) write(*,'(24x,a)') ' track ig       c       j'

      DO              ! Track all grains in the list
         ig=ig+1
         IF (test) THEN
              write(*,'(a,i5)') '[24;34H',ig
         ELSE IF (scr) THEN
              write(*,'(a,a1)') '[24;1H',W(1+mod(ig/10,4))
         ENDIF
!         IF (test) THEN
!            DO icheck=1,5
!                IF (ig.eq.itest(icheck)) EXIT
!            ENDDO
!            logtest =   ig.eq.itest(1)
!      &            .or. ig.eq.itest(2)
!      &            .or. ig.eq.itest(3)
!      &            .or. ig.eq.itest(4)
!      &            .or. ig.eq.itest(5)
!        ENDIF

         DO z=1,nj
            numflg(z)=.true.
         ENDDO
         impfl=.false.
         flxlgd=.false.

!         DO jnew=2,nj          ! determine the (last) particle position
!             IF (grain(ig).pos.y.le.grid.Y(jnew) .or. jnew.eq.nj) EXIT
!         ENDDO
         jnew=grain(ig).ij
         IF (test) write(*,'(a,i3)') '[24;50H',jnew

         DO grain_class=1,NSZ  !     grain class (needed in SPLASH)
           IF (grain(ig).diam .le. grnsz(grain_class)) EXIT
         ENDDO
         grain_vol = grain(ig).diam**3*pi/6.
         grain_mass = grain_dens*grain_vol
         ff=pi*grain(ig).diam**2*fdens/(8.*grain_mass)   ! Force factor ffp
         fa= fdens/grain_dens
         alive=1         ! Mother's alive at the beginning
!
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++!
!                    Time marching for grain No. `ig'                       !
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++!
         dt=deltat
         DO              ! exit if time's up

!           write(*,'(1x,i4,3(1x,e11.4))')
!     &     ig, grain(ig).pos.y, grain(ig).vel.y, grain(ig).el_time
            Pold=grain(ig).pos
            Uold=grain(ig).vel
            IF (ig.eq.457) then
                 fac=1.
            ENDIF

            jold=jnew
            IF (impfl) jold=2
!----           interpolate the fluid velocity at the current location (j)
            j=max(2,jold)
            yp=0.5*(grid.Y(j)+grid.Y(j-1))
            yn=0.5*(grid.Y(j+1)+grid.Y(j))
            IF (Pold.y .ge. yp) THEN
                fac=(yn-Pold.y)/(yn-yp)
                uint.x=fluid.U(j)*fac+fluid.U(j+1)*(1.-fac)
                uoint.x=uo(j)*fac+uo(j+1)*(1.-fac)
            ELSE
                IF (j .gt. 2) THEN
                   ys=0.5*(grid.Y(j-1)+grid.Y(j-2))
                ELSE
                   ys=grid.Y(1)
                ENDIF
                fac=(Pold.y-ys)/(yp-ys)
                uint.x=fluid.U(j)*fac+fluid.U(j-1)*(1.-fac)
                uoint.x=uo(j)*fac+uo(j-1)*(1.-fac)
            ENDIF
            Urel.x=Uint.x-Uold.x
            Urel.y=Uint.y-Uold.y
!
!....           try enlarging the time step first
            DO
               IF ( abs(Uold.y)*dt .gt.&
                   0.11*abs(grid.Y(max(1,jold-1))-grid.Y(jold))&
                    .or. Pold.y + dt*Uold.y.le.grid.Y(1)&
                   .or.  dt.ge.1.e-1*tstep       ) EXIT
               dt = 1.2*dt                                    ! by 20%
            ENDDO
!
!....           then maybe make it smaller again
            DO 
               IF ( abs(Uold.y)*dt .lt. & 
                  0.1*abs(grid.Y(max(1,jold-1))-grid.Y(jold))& 
                         ) EXIT
               dt = 0.5*dt            ! by 50%
            ENDDO
!----            New particle positions
            grain(ig).pos.x=Pold.x+Uold.x*dt
            grain(ig).pos.y=Pold.y+Uold.y*dt

            impfl=grain(ig).pos.y .le. grid.Y(1)
            grain(ig).pos.y=max(grid.Y(1),grain(ig).pos.y)
!
!----           Added mass plus pressure term (accelerations)
            add_pres.x=fa*(1.5*(uint.x-uoint.x)/tstep-0.5*grain(ig).acc.x)
            add_pres.y=fa*(-0.5*grain(ig).acc.y)
!
!====           Particle VELOCITY     ...with old accelaration
            grain(ig).vel.x=grain(ig).vel.x+grain(ig).acc.x*dt
            grain(ig).vel.y=grain(ig).vel.y+grain(ig).acc.y*dt
!
!----           and then NEW Particle acceleration dU_p/dt
            urel_mag=sqrt(Urel.x**2+Urel.y**2)
            re=fdens*urel_mag*grain(ig).diam/visco
            ffp=ff*cd(re)*urel_mag
            grain(ig).acc.x=(Gravit.x+ffp*Urel.x+add_pres.x)
            grain(ig).acc.y=(Gravit.y+ffp*Urel.y+add_pres.y)
!
c         if(iter.eq.19 .and. ig.eq.33) then
c           write(6,*) grain(ig).acc.x,Gravit.x,ffp,Urel.x,add_pres.x
c           write(6,*) grain(ig).acc.y,Gravit.y,ffp,Urel.y,add_pres.y
c           write(6,*) Uint.x,Uint.y,Uold.x,Uold.y
c           write(6,*) ff,cd(re),re,urel_mag
c           write(6,*) fdens,grain(ig).diam,ig,visco
c         endif
!....           time step done, accept it:
            grain(ig).el_time=grain(ig).el_time+dt
            time_up=grain(ig).el_time.ge.tstep
!======================= TEST TEST TEST ========================
!            IF (test .and. logtest) THEN
!                testim(icheck)=testim(icheck)+dt
!                write(icht(icheck),*) testim(icheck),grain(ig).pos.x,grain(ig).pos.y& 
!                  ,grain(ig).vel.x,grain(ig).vel.y,grain(ig).acc.x
!             ENDIF
!======================= TEST TEST TEST ========================
!
!----           determine NEW particle location (No. of CV)
            DO jnew=2,nj
                IF (grain(ig).pos.y.le.grid.Y(jnew)) EXIT
            ENDDO
            IF (grain(ig).pos.y .gt. grid.Y(nj)) THEN
                 write(*,*) ' Particle too high: ', grain(ig).pos.y
                 STOP
            ENDIF
            IF (impfl) jnew=1

            fac1=1.
            IF (jnew.ne.jold) THEN
                IF (grain(ig).vel.y .gt. 0.) THEN
!....                     UPWARD
                    fac1=(grid.Y(jold)-Pold.y)/(grain(ig).pos.y-Pold.y+1.e-30)
                ELSE
!....                     DOWNWARD
                    fac1=(Pold.y-grid.Y(max(1,jold-1)))/(Pold.y-grain(ig).pos.y+1.e-30)
                ENDIF
            ENDIF

            MaxPos.x=max(MaxPos.x,grain(ig).pos.x)
            MaxPos.y=max(MaxPos.y,grain(ig).pos.y)
            MaxVel.x=max(MaxVel.x,grain(ig).vel.x)
            MaxVel.y=max(MaxVel.y,grain(ig).vel.y)

            dmom(jold).x=dmom(jold).x + (grain(ig).vel.x-Uold.x)*grain_mass*fac
            dmom(jnew).x=dmom(jnew).x + (grain(ig).vel.x-Uold.x)*grain_mass*(1.-fac)
!
!******************************* THE TEST *********************************
!            IF (test .and. uint.x.lt.grain(ig).vel.x  .and. jold.eq.2)
!     &                  write(*,'(1(i4,1x),6(e11.4,1x))')
!     &                  ig,grain(ig).vel.y,uint.x,urel.x, fac
!     &                 ,(grain(ig).vel.x-Uold.x), grain(ig).acc.x
!******************************* THE TEST *********************************

            IF (grain(ig).pos.x .gt. bedlen) THEN
                dflux(jold)=dflux(jold)+grain_mass          ! Rugby Count
                grain(ig).pos.x=grain(ig).pos.x-bedlen
            ENDIF
            IF (grain(ig).el_time .ge. .5*tstep .and. .not.flxlgd) THEN
                flxlgd=.true.
                mom.x=grain_mass*grain(ig).vel.x
                tmflx=tmflx+mom.x                     ! x-Momentum of ALL grains

                dtmflx(jold)=dtmflx(jold)+mom.x*fac   ! same, but per CV
                conc(jold)=conc(jold)+grain_mass*fac  ! for Concentration (mass load)
                rnumb(jold)=rnumb(jold)+fac
                pvol(jold)=pvol(jold)+grain_vol*fac   ! Vol %

                dtmflx(jnew)=dtmflx(jnew)+mom.x*(1.-fac)
                rnumb(jnew)=rnumb(jnew)+(1.-fac)
                conc(jnew)=conc(jnew)+grain_mass*(1.-fac)
                pvol(jnew)=pvol(jnew)+grain_vol*(1.-fac)
            ENDIF
            IF (numflg(jnew)) THEN
                numflg(jnew)=.false.
                number(jnew)=number(jnew)+1
            ENDIF
            midafl = .true.
            rvol=area*(grid.Y(jold)-grid.Y(jold-1))
            pcoll=(rnumb(jold)/rvol)*pi*grain(ig).diam*grain(ig).diam*& 
                  sqrt(Uold.x*Uold.x+Uold.y*Uold.y)*dt
            pcoll=-1.0
c    pcoll = -1 kills off mid air collision routine
            if (midafl .and. pcoll.gt.randm()) then
                  midafl = .false.
                  nmid(iter,0)=nmid(iter,0)+1
                  nmid(iter,jnew)=nmid(iter,jnew)+1
                  collis_count=collis_count+1
                  IF (test) write(*,'(a,i3)') '[24;43H',collis_count
c                  write(6,*) 'midair collision'
                  spl(1)=grain(ig)
                  CALL SUB_GRAINS(ig,vtx,vty,jnew,igdel)
                  urx=grain(ig).vel.x-vtx  
                  ury=grain(ig).vel.y-vty  
                  CALL MIDAIR(urx,ury,grain(ig).diam)
                  spl(1).vel.x=spl(1).vel.x+vtx
                  spl(1).vel.y=spl(1).vel.y+vty
                  spl(2).vel.x=spl(2).vel.x+vtx
                  spl(2).vel.y=spl(2).vel.y+vty
                  spl(2).ij=grain(ig).ij
                  grain(ig)=spl(1)           
                  grain(igdel)=spl(2)
                   
                  DO z=1,nj
                     numflg(z)=.true.        ! Now she hasn't been anywhere yet.
                  ENDDO                       ! (new path for mother)
! obsolete          CALL ADD_GRAINS(1,1,lost)
            ENDIF 
!                   new particles into the calculation (produced in splash)
            IF (impfl) THEN
                Impacts=Impacts+1
                spl(1)=grain(ig)
                CALL SPLASH(grain_class,ejected,alive,born)
                Ejecta=Ejecta+ejected
                IF (alive.eq.0) THEN
                    Deads = Deads+1
                    grain(ig).diam=0.
                    grain(ig).el_time=0.
!                    IF (logtest) testim(icheck)=0.
                ELSE
                    grain(ig)=spl(1)           ! mother bounces and gets new values
                    DO z=1,nj
                        numflg(z)=.true.        ! Now she hasn't been anywhere yet.
                    ENDDO                       ! (new path for mother)
                ENDIF
                IF (born.gt.0) THEN
                   Daughters=Daughters+born
                   CALL ADD_GRAINS(alive,born,lost)
                ENDIF
                IF (sample) CALL SAMP(born+alive)
            ENDIF
            grain(ig).ij=max(2,jnew)

            IF (time_up .or. alive.eq.0) EXIT
         ENDDO
         
         IF (ig.eq.NGRAINS .or. grain(ig+1).diam .eq. 0.0) EXIT
      ENDDO
      END
