      SUBROUTINE WRITING
!***********************************************************************
!     final ouput writing
!***********************************************************************
      INCLUDE 'params.inc'
      INCLUDE 'pars.inc'
      INCLUDE 'particle.inc'
      INCLUDE 'discrete.inc'
      INCLUDE 'timing.inc'
      INCLUDE 'tracom.inc'
      INCLUDE 'strecom.inc'
      INCLUDE 'splsh.inc'
      INCLUDE 'statist.inc'
      INCLUDE 'pszdstr.inc'
      INCLUDE 'midairmod.inc'
      INCLUDE 'outdirmod.inc'
      use averag

      INTEGER i,iaveje,j,kn
      INTEGER vnum,unum,samsta,samend
      COMMON /sampling/ samsta,samend
      REAL  ejcr,gstress,V
      REAL vmean,umean,vvar,uvar,dx,hflux
      REAL N
      INTEGER ic1,ic2,ic3,ic5,ic6,ic7,ic8,ic9

!
!---- file handling ,  OUTDIR defined in file 'outdir.inc'
      DATA ic1,ic2,ic3,ic5,ic6,ic7,ic8,ic9   /91,92,93,95,96,97,98,99/

!      open(ic1,file=OUTDIR(1:Laenge)//'eins.dat')
      OPEN(ic2,file=OUTDIR(1:Laenge)//'zwo.dat')
      OPEN(ic5,file=OUTDIR(1:Laenge)//'numconc.dat')
      OPEN(ic7,file=OUTDIR(1:Laenge)//'splash.dat')
      OPEN(ic8,file=OUTDIR(1:Laenge)//'velstat.dat')
      OPEN(ic9,file=OUTDIR(1:Laenge)//'midair.dat')

      hflux=0.
      DO j=2,njm
        hflux=hflux+dflux(j)/(tstep*bedwid*(grid.y(j)-grid.y(j-1)))
        vflux(j)=vflux(j)/(area*tstep)
      ENDDO
      vflux(1)=vflux(1)/(area*tstep)
!
!----     File No. 2      gstress is wrong!
      write(ic2,905)& 
           '  Y    ',' sh.str',' gstr  ',' xfrc  ',' ymom  ','  sum  '
      gstress=dmom(2).x/(area)
      write(ic2,903) grid.y(1)& 
        ,tau(1),gstress,dmom(2).x,dmom(2).y,gstress+tau(1)
      DO i=2,nj
        gstress=dmom(i).x/(area)
        write(ic2,903) 0.5*(grid.y(i)+grid.y(i-1)),& 
          tau(i),gstress,dmom(i).x,dmom(i).y,gstress+tau(i)
      ENDDO
      CLOSE(ic2)
!
!----     File No. 5
      write(ic5,911) ' Particle Number and Number Concentration Profile'
      write(ic5,912) ' averaged over ',samcnt,' iterations'
      samcnt=max(1,samcnt)
      write(ic5,913) ' IT start: ',samsta,'  IT end: ',samend& 
      , ' CV No.      H [m]          V [m3] '& 
      ,'            N           N/V [-/m3]'
      DO j=njm,2,-1
        V=grid.y(j)-grid.y(j-1)
        write(ic5,910) & 
          j,0.5*(grid.y(j)+grid.y(j-1)),V,float(Anzahl(j))/float(samcnt)& 
             ,float(Anzahl(j))/(float(samcnt)*V)
      ENDDO
      CLOSE(ic5)
!
!---  File seven (SPLASH.DAT) to keep splash information
!
      write(ic7,*) ' MaxPos.x      MaxPos.y      MaxVel.x      MaxVel.y'
      write(ic7,'(4(e12.5,1x))')  MaxPos.x, MaxPos.y, MaxVel.x, MaxVel.y
      write(ic7,*)' Epsilon (1,2,3):'
      write(ic7,999)  ep1,ep2,ep3
  999 FORMAT(3(f4.1,:,','))
      write(ic7,*)' Number of splashed grains in size k:'
      write(ic7,998) (ns(i),i=1,nsz)
      write(ic7,*)' Number of ejected grains in size k:'
      write(ic7,998) (neject(i),i=1,nsz)
  998 FORMAT(3(i7,:,','))
      write(ic7,*) '________________________'
      write(ic7,*) ' Average splash values:'
      DO i=1,nsz
          N=float(ns(i))+1.e-30
          iaveje=max(1,neject(i))
          ejcr=float(neject(i))/N
          write(ic7,103) 'Size No.',i,' Splashes:',ns(i)& 
           ,' ejecta:',neject(i)
          write(ic7,106) bonc_aver(i).v_in/N,bonc_aver(i).a_in*57.3/N& 
                ,bonc_aver(i).v_out/N,bonc_aver(i).a_out*57.3/N
        ENDDO
        write(ic7,'(a/a)') 'v_in/ns(i), a_in/ns(i) degr',& 
                     'v_out/ns(i), a_out/ns(i) degr '
          write(ic7,106) MaxPos.x,MaxPos.y,MaxVel.x,MaxVel.y
      CLOSE(ic7)
!
!----    File No. 8
      write(ic8,'(a/a)') ' Statistics on Particle Velocities' &  
        ,' U-Velocity increments and Number Count'
      umean=0.
      uvar=0.
      unum=0
      DO i=1,nu
        write(ic8,'(e12.5,1x,i6)') ui(i),numu(i)
        umean=umean+ui(i)*numu(i)
        unum=unum+numu(i)
        uvar=uvar+ui(i)**2*numu(i)
      ENDDO
      umean=umean/max(1,unum)
      uvar=uvar/max(1,(unum-1))-umean**2
      uvar=sqrt(uvar)
      write(ic8,'(a,i8,1x,2(a,e12.5)//a)')& 
          ' U-Num:',unum,' Umean:',umean,' Std-U:',uvar& 
          ,' V-Velocity increments and Number Count'
      vmean=0.
      vvar=0.
      vnum=0
      DO i=1,nv
        write(ic8,'(e12.5,1x,i6)') vj(i),numv(i)
        vmean=vmean+vj(i)*numv(i)
        vnum=vnum+numv(i)
        vvar=vvar+vj(i)**2*numv(i)
      ENDDO
      vmean=vmean/max(1,vnum)
      vvar=vvar/max(1,(vnum-1))-vmean**2
      vvar=sqrt(vvar)
      write(ic8,'(a,i8,1x,2(a,e12.5))')& 
           ' V-Num:',vnum,' Vmean:',vmean,' Std-V:',vvar
      write(ic8,'(a/a)') ' Particle Size distribution'& 
       ,' mesh [um]   Number        rel         SNum       relSum '
!....    now vmean,vnum,vvar  are used for particle size!!!!!!!
      vmean=0.
      vvar=0.
      vnum=0
      N=0.
      DO i=1,Ntray
        N=N+float(nums(i))
      ENDDO
      N=N+1.e-30
      DO i=1,Ntray
         dx=0.5*(mesh(i)+mesh(i-1))
         vmean=vmean+dx*nums(i)
         vnum=vnum+nums(i)
         vvar=vvar+dx**2*nums(i)
         write(ic8,'(3x,f6.1,3x,i8,3x,e12.5,3x,i8,3x,e12.5)')& 
           mesh(i),nums(i),nums(i)/N,vnum,vnum/N
      ENDDO
      vmean=vmean/N
      write(ic8,'(3(a,e10.3))') ' vmean:',vmean,' N:',N,' var:',vvar
      vmean=vmean*1.e-6
      vvar=1.e-12*(vvar/(N-1.)-vmean**2)
      write(ic8,'(1x,a,i10,2(a,e12.5),a2)')& 
           ' Number:',vnum,'  E(Dp):',vmean,' m    Var(Dp):',vvar,' m'
      CLOSE(ic8)



c  writing midair collision data
          write(ic9,*) (nmid(kn,0),kn=1,100)
          write(ic9,*) (nmid(numiter,kn),kn=1,50)
      CLOSE(ic8)
  900 FORMAT(i5,5(1x,e10.3))
  901 FORMAT(a5,5(3x,a7,1x))
  902 FORMAT(/,5(3x,a7,1x))
  903 FORMAT(6(1x,e10.3))
  904 FORMAT(5(1x,e10.3))
  905 FORMAT(6(3x,a7,1x))
  911 FORMAT(a/a)
  910 FORMAT(2x,i3,4(4x,e12.5))
  912 FORMAT(1x,a,i5,a)
  913 FORMAT(1x,2(a,i5),/2a)
  103 FORMAT(a,i2,a,i7,a,i5)
  104 FORMAT(5(1X,e12.5))
  105 FORMAT(i3,2i7)
  106 FORMAT(4(1X,e12.5))
      RETURN
      END
