module writing
  use params
  use particle
  use discrete
!  use timing
!  use tracom
!  use splsh
  use statist
  use pszdstr
  use mid_air_mod
  use sysdep_io  

   
contains
 !$   !***********************************************************************
!!$    !     final ouput writing
!!$    !***********************************************************************
!!$
!!$    integer,intent(in) :: samsta,samend,samcnt,anzahl(:)
!!$
!!$    integer i,iaveje,j,kn
!!$    integer vnum,unum
!!$
!!$    real(r_kind)  ejcr,gstress,v
!!$    real(r_kind) vmean,umean,vvar,uvar,dx,hflux
!!$    real(r_kind) n
!!$    integer ic2,ic5,ic7,ic8,ic9
!!$    !      integer ic1,ic3,ic6
!!$
!!$    !
!!$    !---- file handling ,  outdir defined in file 'outdir%inc'
!!$    !      data ic1,ic2,ic3,ic5,ic6,ic7,ic8,ic9   /91,92,93,95,96,97,98,99/
!!$    call assign_lun(ic2)
!!$    call assign_lun(ic5)
!!$    call assign_lun(ic7)
!!$    call assign_lun(ic8)
!!$    call assign_lun(ic9)
!!$
!!$    !      open(ic1,file=trim(outdir)//'eins%dat')
!!$    open(ic2,file=trim(outdir)//'zwo%dat')
!!$    open(ic5,file=trim(outdir)//'numconc%dat')
!!$    open(ic7,file=trim(outdir)//'splash%dat')
!!$    open(ic8,file=trim(outdir)//'velstat%dat')
!!$    open(ic9,file=trim(outdir)//'midair%dat')
!!$
!!$    hflux=0.
!!$    do j=2,njm
!!$       hflux=hflux+dflux(j)/(tstep*bedwid*(grid%y(j)-grid%y(j-1)))
!!$       vflux(j)=vflux(j)/(area*tstep)
!!$    enddo
!!$    vflux(1)=vflux(1)/(area*tstep)
!!$    !
!!$    !----     file no. 2      gstress is wrong!
!!$    write(ic2,905)& 
!!$         '  y    ',' sh%str',' gstr  ',' xfrc  ',' ymom  ','  sum  '
!!$    gstress=dmom(2)%x/(area)
!!$    write(ic2,903) grid%y(1)& 
!!$         ,tau(1),gstress,dmom(2)%x,dmom(2)%y,gstress+tau(1)
!!$    do i=2,nj
!!$       gstress=dmom(i)%x/(area)
!!$       write(ic2,903) 0.5*(grid%y(i)+grid%y(i-1)),& 
!!$            tau(i),gstress,dmom(i)%x,dmom(i)%y,gstress+tau(i)
!!$    enddo
!!$    close(ic2);call free_lun(ic2)
!!$    !
!!$    !----     file no. 5
!!$    write(ic5,911) ' particle number and number concentration profile'
!!$    write(ic5,912) ' averaged over ',samcnt,' iterations'
!!$    call assert(samcnt>0,'writing.f90: samcnt not positive')
!!$    !samcnt=max(1,samcnt)
!!$    write(ic5,913) ' it start: ',samsta,'  it end: ',samend& 
!!$         , ' cv no.      h [m]          v [m3] '& 
!!$         ,'            n           n/v [-/m3]'
!!$    do j=njm,2,-1
!!$       v=grid%y(j)-grid%y(j-1)
!!$       write(ic5,910) & 
!!$            j,0.5*(grid%y(j)+grid%y(j-1)),v,float(anzahl(j))/float(samcnt)& 
!!$            ,float(anzahl(j))/(float(samcnt)*v)
!!$    enddo
!!$    close(ic5);call free_lun(ic5)
!!$    !
!!$    !---  file seven (splash%dat) to keep splash information
!!$    !
!!$    write(ic7,*) ' maxpos%x      maxpos%y      maxvel%x      maxvel%y'
!!$    write(ic7,'(4(e12.5,1x))')  maxpos%x, maxpos%y, maxvel%x, maxvel%y
!!$    write(ic7,*)' epsilon (1,2,3):'
!!$    write(ic7,999)  ep1,ep2,ep3
!!$999 format(3(f4.1,:,','))
!!$    write(ic7,*)' number of splashed grains in size k:'
!!$    write(ic7,998) (ns(i),i=1,nsz)
!!$    write(ic7,*)' number of ejected grains in size k:'
!!$    write(ic7,998) (neject(i),i=1,nsz)
!!$998 format(3(i7,:,','))
!!$    write(ic7,*) '________________________'
!!$    write(ic7,*) ' average splash values:'
!!$    do i=1,nsz
!!$       n=float(ns(i))+1.e-30
!!$       iaveje=max(1,neject(i))
!!$       ejcr=float(neject(i))/n
!!$       write(ic7,103) 'size no.',i,' splashes:',ns(i)& 
!!$            ,' ejecta:',neject(i)
!!$       write(ic7,106) bonc_aver(i)%v_in/n,bonc_aver(i)%a_in*57.3/n& 
!!$            ,bonc_aver(i)%v_out/n,bonc_aver(i)%a_out*57.3/n
!!$    enddo
!!$    write(ic7,'(a/a)') 'v_in/ns(i), a_in/ns(i) degr',& 
!!$         'v_out/ns(i), a_out/ns(i) degr '
!!$    write(ic7,106) maxpos%x,maxpos%y,maxvel%x,maxvel%y
!!$    close(ic7);call free_lun(ic7)
!!$    !
!!$    !----    file no. 8
!!$    write(ic8,'(a/a)') ' statistics on particle velocities' &  
!!$         ,' u-velocity increments and number count'
!!$    umean=0.
!!$    uvar=0.
!!$    unum=0
!!$    do i=1,nu
!!$       write(ic8,'(e12.5,1x,i6)') ui(i),numu(i)
!!$       umean=umean+ui(i)*numu(i)
!!$       unum=unum+numu(i)
!!$       uvar=uvar+ui(i)**2*numu(i)
!!$    enddo
!!$    umean=umean/max(1,unum)
!!$    uvar=uvar/max(1,(unum-1))-umean**2
!!$    uvar=sqrt(uvar)
!!$    write(ic8,'(a,i8,1x,2(a,e12.5)//a)')& 
!!$         ' u-num:',unum,' umean:',umean,' std-u:',uvar& 
!!$         ,' v-velocity increments and number count'
!!$    vmean=0.
!!$    vvar=0.
!!$    vnum=0
!!$    do i=1,nv
!!$       write(ic8,'(e12.5,1x,i6)') vj(i),numv(i)
!!$       vmean=vmean+vj(i)*numv(i)
!!$       vnum=vnum+numv(i)
!!$       vvar=vvar+vj(i)**2*numv(i)
!!$    enddo
!!$    vmean=vmean/max(1,vnum)
!!$    vvar=vvar/max(1,(vnum-1))-vmean**2
!!$    vvar=sqrt(vvar)
!!$    write(ic8,'(a,i8,1x,2(a,e12.5))')& 
!!$         ' v-num:',vnum,' vmean:',vmean,' std-v:',vvar
!!$    write(ic8,'(a/a)') ' particle size distribution'& 
!!$         ,' mesh [um]   number        rel         snum       relsum '
!!$    !....    now vmean,vnum,vvar  are used for particle size!!!!!!!
!!$    vmean=0.
!!$    vvar=0.
!!$    vnum=0
!!$    n=0.
!!$    do i=1,ntray
!!$       n=n+float(nums(i))
!!$    enddo
!!$    n=n+1.e-30
!!$    do i=1,ntray
!!$       dx=0.5*(mesh(i)+mesh(i-1))
!!$       vmean=vmean+dx*nums(i)
!!$       vnum=vnum+nums(i)
!!$       vvar=vvar+dx**2*nums(i)
!!$       write(ic8,'(3x,f6.1,3x,i8,3x,e12.5,3x,i8,3x,e12.5)')& 
!!$            mesh(i),nums(i),nums(i)/n,vnum,vnum/n
!!$    enddo
!!$    vmean=vmean/n
!!$    write(ic8,'(3(a,e10.3))') ' vmean:',vmean,' n:',n,' var:',vvar
!!$    vmean=vmean*1.e-6
!!$    vvar=1.e-12*(vvar/(n-1.)-vmean**2)
!!$    write(ic8,'(1x,a,i10,2(a,e12.5),a2)')& 
!!$         ' number:',vnum,'  e(dp):',vmean,' m    var(dp):',vvar,' m'
!!$    close(ic8);call free_lun(ic8)
!!$
!!$
!!$
!!$    !  writing midair collision data
!!$    write(ic9,*) (nmid(kn,0),kn=1,100)
!!$    write(ic9,*) (nmid(numiter,kn),kn=1,50)
!!$    close(ic9);call free_lun(ic9)
!!$900 format(i5,5(1x,e10.3))
!!$901 format(a5,5(3x,a7,1x))
!!$902 format(/,5(3x,a7,1x))
!!$903 format(6(1x,e10.3))
!!$904 format(5(1x,e10.3))
!!$905 format(6(3x,a7,1x))
!!$911 format(a/a)
!!$910 format(2x,i3,4(4x,e12.5))
!!$912 format(1x,a,i5,a)
!!$913 format(1x,2(a,i5),/2a)
!!$103 format(a,i2,a,i7,a,i5)
!!$104 format(5(1x,e12.5))
!!$105 format(i3,2i7)
!!$106 format(4(1x,e12.5))

  end subroutine write_all
  subroutine wrtout(iterat,aero,grains,fstwrt)
    !***********************************************************************
    !     final ouput writing
    !***********************************************************************
    use params
    use particle
!    use tracom
!    use splashmod
!    use splsh
!    use strecom
!    use timing
!    use discrete
    use outdirmod
    use sysdep_io
    use opfi2

    integer aero
    integer grains
    integer iterat
    logical fstwrt
!!$    integer jj,idum
!!$    integer ic4a, ic4b, ic4c, ic4d,rla, rlb, rlc, rld,nrca, nrcb, nrcc, nrcd
!!$    integer endline
!!$    !---- endline character is 13 on dos, os/2 and 10 on hp-unix
!!$    data endline /10/! /13/   ! change accordingly , char(32)=space
!!$
!!$    real(r_kind) totfi,totfl,totf2,a
!!$    real(r_kind) dum,t,fac,ustar3,ustar8,gstrh
!!$    !         gstrh - grain borne stress at max height
!!$
!!$    logical newa,newb,newc,newd
!!$    
!!$    !logical new
!!$    character(len=12) filea, fileb, filec, filed
!!$    character(len=1) cdum
!!$    dimension a(nymax)
!!$    !
!!$    !---- file handling
!!$    filea = 'numbers.dat'
!!$    fileb = 'angles.dat'
!!$    filec = 'rates.dat'
!!$    filed = 'stress.dat'
!!$    !...  unit numbers
!!$
!!$    call assign_lun(ic4a)
!!$    call assign_lun(ic4b)
!!$    call assign_lun(ic4c)
!!$    call assign_lun(ic4d)
!!$
!!$    !...  record lengths
!!$    rla = 76
!!$    rlb = 56
!!$    rlc = 58
!!$    rld = 141
!!$    dum=0.
!!$    idum=0
!!$    fac=180./pi
!!$    !
!!$    !---  open the files:
!!$    !
!!$    call opfi2_write(trim(outdir)//filea,ic4a&
!!$         ,'formatted',rla,nrca,fstwrt,newa)
!!$    call opfi2_write(trim(outdir)//fileb,ic4b&
!!$         ,'formatted',rlb,nrcb,fstwrt,newb)
!!$    call opfi2_write(trim(outdir)//filec,ic4c&
!!$         ,'formatted',rlc,nrcc,fstwrt,newc)
!!$    call opfi2_write(trim(outdir)//filed,ic4d&
!!$         ,'formatted',rld,nrcd,fstwrt,newd)
!!$    if ( .not. newa) then
!!$       read(ic4a,101,rec=1) nrca,dum,idum,idum,idum,idum,idum,idum&
!!$            ,dum,dum,cdum
!!$    else
!!$       write(ic4a,101,rec=1) nrca,dum,idum,idum,idum,idum,idum,idum&
!!$            ,dum,dum,char(endline)
!!$    endif
!!$    if ( .not. newb) then
!!$       read(ic4b,102,rec=1) nrcb,dum,dum,dum,dum,dum,idum&
!!$            ,cdum
!!$    else
!!$       write(ic4b,102,rec=1) nrcb,dum,dum,dum,dum,dum,idum&
!!$            ,char(endline)
!!$    endif
!!$    if ( .not. newc) then
!!$       read(ic4c,103,rec=1) nrcc,dum,dum,dum,dum&
!!$            ,cdum
!!$    else
!!$       write(ic4c,103,rec=1) nrcc,dum,dum,dum,dum&
!!$            ,char(endline)
!!$    endif
!!$    if ( .not. newd) then
!!$       read(ic4d,104,rec=1) nrcd,dum,dum,dum,dum,dum,dum,dum,dum,dum,dum&
!!$            ,cdum
!!$    else
!!$       write(ic4d,104,rec=1) nrcd,dum,dum,dum,dum,dum,dum,dum,dum,dum,dum&
!!$            ,char(endline)
!!$    endif
!!$    area=bedwid*bedlen
!!$
!!$
!!$    !
!!$    !---- contemporary flux data per unit area and unit time
!!$    !     factor for write-out do-loop:
!!$
!!$    do jj=2,nymax-1
!!$       a(jj)=bedwid*(grid%y(jj)-grid%y(jj-1))
!!$    enddo
!!$    !...    think this one over
!!$    a(nymax)=1.
!!$
!!$    totfi=0.
!!$    totf2=0.
!!$    gstrh=0.
!!$    do jj=2,nymax-1
!!$       totfi=totfi+dflux(jj)
!!$       totf2=totf2+dtmflx(jj)
!!$       !        dflux(jj)=dflux(jj)/(tstep*a(jj))
!!$       gstrh=gstrh+dmom(jj)%x
!!$    enddo
!!$    gstrh=gstrh/(area*tstep)
!!$
!!$    totfl=totfi/(bedwid*tstep)
!!$    totf2=totf2/(area)
!!$    !
!!$    !...  into 4a
!!$    nrca=nrca+1
!!$    write(ic4a,101,rec=nrca) iterat,iterat*tstep&
!!$         ,aero,daughters,-deads,grains,impacts,ejecta&
!!$         ,impacts/(area*tstep),ejecta/(area*tstep)&
!!$         &     ,char(endline)
!!$    !
!!$    !...  into 4b
!!$    nrcb=nrcb+1
!!$    t=(float(impacts-deads)+1.e-30)    ! truly rebound grains
!!$    write(ic4b,102,rec=nrcb)&
!!$         iterat,iterat*tstep,av%v_in/t,av%a_in*fac/t,av%v_out/t,av%a_out*fac/t&
!!$         ,impacts-deads,char(endline)
!!$    !
!!$    !...  into 4c (rates%dat)
!!$    nrcc=nrcc+1
!!$    write(ic4c,103,rec=nrcc) iterat, iterat*tstep&
!!$         ,totfl,tmflx/(area),totf2&
!!$         ,char(endline)
!!$    !
!!$    !...  into 4d
!!$    ustar3=sign(sqrt(abs(tau(2))/fdens),tau(2))
!!$    ustar8=sign(sqrt(abs(tau(nj-5))/fdens),tau(nj-5))
!!$    ! this would work for sinus:
!!$    !      ustar8=vkarman*(fluid%u(nj)-fluid%u(nj-5))/log(grid%y((nj)/grid%y((nj-5))
!!$
!!$    nrcd=nrcd+1
!!$    write(ic4d,104,rec=nrcd) iterat, iterat*tstep&
!!$         ,tmflx/(area),totfl,tau(2),ustar3,tau(nj-5),ustar8&
!!$         ,gstrh,fluid%u(16),fluid%u(njm)&
!!$         !
!!$         !          ,totfl,gstrh,tau(2),ustar2,ustar3,fluid%u(njm)&
!!$         !          ,fluid%u(2),tau(2),fluid%u(njm/2),fluid%u(njm)&
!!$    ,char(endline)
!!$    !
!!$    !---  closing the files
!!$    write(ic4a,101,rec=1) nrca,dum,idum,idum,idum,idum,idum,idum,dum,dum&
!!$         ,char(endline)
!!$    write(ic4b,102,rec=1) nrcb,dum,dum,dum,dum,dum,idum&
!!$         ,char(endline)
!!$    write(ic4c,103,rec=1) nrcc,dum,dum,dum,dum&
!!$         ,char(endline)
!!$    write(ic4d,104,rec=1) nrcd,dum,dum,dum,dum,dum,dum,dum,dum,dum,dum&
!!$         ,char(endline)
!!$    close(ic4a);call free_lun(ic4a)
!!$    close(ic4b);call free_lun(ic4b)
!!$    close(ic4c);call free_lun(ic4c)
!!$    close(ic4d);call free_lun(ic4d)
!!$    !
!!$    !---- formats and such
!!$    !     for 4a:
!!$101 format(i5,1x,e11.4,6(1x,i5),2(1x,e10.3),a)
!!$    !     for 4b:
!!$102 format(i5,1x,e11.4,4(1x,f7.2),1x,i5,a)
!!$    !     for 4c:
!!$103 format(i5,4(1x,e12.5),a)
!!$    !     for 4d:
!!$104 format(i5,10(1x,e12.5),a)
!!$    !.... keep these 'close' for possible system crashes and 'ctrl-c's
!!$    return
  end subroutine wrtout
end module writing
