# 1 "ireg_f90_def.F90"
# 1 "/home/jim/fortran/library/dimension.h" 1 
!Define preprocessor macros that define the dimension
!Default is Three dimensions
!Overide by compiling with -DTWODIM or defining 1 before this is included
!If the file is directly edited then the dependencies will cause the correct files
!to be recompiled so this is probably best
 
# 11


! Commands only for three dimensions use the macro CMD3() 
# 20


! Commands only for two dimensions use the macro CMD2()








# 2 "/home/jim/fortran/library/ireg_f90_def.F90" 2 
module ireg_f90_def
  use precision
  use ivec_f90_def
  implicit none
 type, public :: ireg_t   ! Integer region
     type(ivec_t) min
     type(ivec_t) max
  end type ireg_t 
!  type(ireg_t), parameter :: null_ireg = ireg_t(null_ivec,null_ivec) SR2201BUG
  type(ireg_t) :: null_ireg = ireg_t(ivec_t(0,0),ivec_t(0,0))

  interface operator(<) 
     module procedure le_ireg_ireg
  end interface
  
  interface operator(>) 
     module procedure  ge_ireg_ireg
  end interface

  interface operator(<=) 
     module procedure leq_ireg_ireg
  end interface

  interface operator(>=) 
     module procedure geq_ireg_ireg
  end interface

 interface operator(*)
     module procedure  i_mult_ireg
  end interface

  interface volume
     module procedure  ireg_volume
  end interface
  interface inside
     module procedure  ireg_v_inside, ireg_av_inside
  end interface

  interface shrink
     module procedure  ireg_shrink
  end interface
  interface grow
     module procedure ireg_grow
  end interface
 
contains
  subroutine aireg_equ_aireg(a,b) ! Assignment of a region
    type(ireg_t),intent(in)  :: b(:)
    type(ireg_t),intent(out) :: a(size(b))
    a%min = b%min; a%max = b%max
   end subroutine aireg_equ_aireg
   function ireg_volume(a) ! Volume of a region
    type(ireg_t),intent(in) :: a
    integer :: ireg_volume
    ireg_volume = volume(a%max-a%min)
  end function ireg_volume
  function ireg_v_inside(a,b) ! Is a vector inside a region
    type(ireg_t),intent(in) :: a
    type(ivec_t), intent(in) :: b
    logical :: ireg_v_inside
    ireg_v_inside = a%min<=b .and. a%max>=b
  end function ireg_v_inside  ! Which vectors from an array are inside a region
  function ireg_av_inside(a,b)
    type(ireg_t),intent(in) :: a
    type(ivec_t), intent(in) :: b(:)
    logical :: ireg_av_inside(size(b))
    ireg_av_inside = a%min<=b .and. a%max>=b
  end function ireg_av_inside
  function ireg_grow(a,b)    ! Return a region increased by b
    type(ireg_t),intent(in) :: a
    integer, intent(in) :: b
    type(ireg_t) :: ireg_grow
    ireg_grow%min = a%min-scalar_to_ivec(b)
    ireg_grow%max = a%max+scalar_to_ivec(b)
  end function ireg_grow
  function ireg_shrink(a,b)    ! Return a region shrunk by b
    type(ireg_t),intent(in) :: a
    integer, intent(in) :: b
    type(ireg_t) :: ireg_shrink
    ireg_shrink%min = a%min+scalar_to_ivec(b);
    ireg_shrink%max = a%max-scalar_to_ivec(b)
  end function ireg_shrink
  function ireg_union_ireg(a,b) ! Return the union of two regions
    type(ireg_t),intent(in) :: a,b
    type(ireg_t) :: ireg_union_ireg
    ireg_union_ireg%min = min(a%min,b%min);ireg_union_ireg%max = max(a%max,b%max)
  end function ireg_union_ireg
 function i_mult_ireg(a,b) result(rg)
    type(ireg_t), intent(in) :: b
    integer, intent(in) :: a
    type(ireg_t) :: rg
    rg%min = a * b%min; rg%max = a* b%max
  end function i_mult_ireg
  function le_ireg_ireg(a,b) result(r)!Is a region a contained in a region b
    type(ireg_t), intent(in) :: a
    type(ireg_t), intent(in) :: b
    logical :: r
    r = a%min>b%min .and. a%max<b%max
  end function le_ireg_ireg
  function ge_ireg_ireg(a,b) result(r)!Is a region a contained in a region b
    type(ireg_t), intent(in) :: a
    type(ireg_t), intent(in) :: b
    logical :: r
    r = a%min<b%min .and. a%max>b%max
  end function ge_ireg_ireg
  function leq_ireg_ireg(a,b) result(r)!Is a region a contained in a region b
    type(ireg_t), intent(in) :: a
    type(ireg_t), intent(in) :: b
    logical :: r
    r = a%min>=b%min .and. a%max<=b%max
  end function leq_ireg_ireg
  function geq_ireg_ireg(a,b) result(r)!Is a region a contained in a region b
    type(ireg_t), intent(in) :: a
    type(ireg_t), intent(in) :: b
    logical :: r
    r = a%min<=b%min .and. a%max>=b%max
  end function geq_ireg_ireg


end module ireg_f90_def

