# 1 "rang_f90_def.F90"
# 1 "/home/jim/fortran/library/dimension.h" 1 
!Define preprocessor macros that define the dimension
!Default is Three dimensions
!Overide by compiling with -DTWODIM or defining 1 before this is included
!If the file is directly edited then the dependencies will cause the correct files
!to be recompiled so this is probably best
 
# 11


! Commands only for three dimensions use the macro CMD3() 
# 20


! Commands only for two dimensions use the macro CMD2()








# 2 "/home/jim/fortran/library/rang_f90_def.F90" 2 
! Module for angular velocity type 
! In two dimensions this is a scalar
! In three dimensions a vector
! in general it is an 1/2d(d - 1) dimensional chain
! though this module is restricted to consider only 2d and 3d
! In the 3d case and rang_t type is considered as a vector 
! with a single z component



# 14







module rang_f90_def
  use precision
  implicit none
  type, public :: rang_t ! Real(R_kind) vector
     
     
     real(r_kind) z
  end type rang_t

!  type(rang_t), parameter :: null_rang = rang_t(0) SR2201BUG
  type(rang_t) :: null_rang = rang_t(0)

  interface arang_t
     module procedure arang_t
  end interface
  interface assignment(=)
     module procedure arang_equ_arang
  end interface
  interface operator(==)
     module procedure rang_eq_rang, arang_eq_arang
  end interface
  interface operator(/=)
     module procedure rang_neq_rang, arang_neq_arang
  end interface
  interface operator(<) 
     module procedure le_rang_rang, le_rang_arang, le_arang_rang, le_arang_arang
  end interface
  interface operator(>) 
     module procedure ge_rang_rang, ge_rang_arang, ge_arang_rang, ge_arang_arang
  end interface
  interface operator(<=) 
     module procedure leq_rang_rang, leq_rang_arang, leq_arang_rang, leq_arang_arang
  end interface
  interface operator(>=) 
     module procedure geq_rang_rang, geq_rang_arang, geq_arang_rang, geq_arang_arang
  end interface
  interface operator(+)
     module procedure &
          rang_add_rang, arang_add_arang, rang_add_arang, arang_add_rang
  end interface
  interface operator(-)
     module procedure neg_rang, neg_arang, &
          rang_sub_rang, arang_sub_arang, rang_sub_arang, arang_sub_rang
  end interface
  interface operator(*)
     module procedure &
          rang_mult_r, r_mult_rang, arang_mult_r, r_mult_arang, &
          rang_mult_i, i_mult_rang, arang_mult_i, i_mult_arang, &
          rang_mult_ar, ar_mult_rang, arang_mult_ar, ar_mult_arang, &
          rang_mult_ai, ai_mult_rang, arang_mult_ai, ai_mult_arang
  end interface
  interface operator(/)
     module procedure div_rang_r, div_arang_r, div_arang_ar, &
          div_rang_i, div_arang_i, div_arang_ai 
  end interface
  interface operator(.dot.)
     module procedure dot_rang_rang, dot_arang_arang, dot_rang_arang, dot_arang_rang
  end interface
  interface length
     module procedure length_rang, length_arang
  end interface
  interface length_sqr
     module procedure length_sqr_rang, length_sqr_arang
  end interface
  interface distance
     module procedure distance_rang, distance_arang
  end interface
  interface distance_sqr
     module procedure distance_sqr_rang, distance_sqr_arang
  end interface
  interface sum
     module procedure sum_arang
  end interface
  interface minval
     module procedure minval_arang
  end interface
  interface maxval
     module procedure maxval_arang
  end interface
  interface max
     module procedure max_rang
  end interface
  interface min
     module procedure min_rang
  end interface
  interface random_number
     module procedure rang_random_number, arang_random_number
  end interface
  interface stats
     module procedure arang_stats
  end interface
  interface random_unit_vector
     module procedure rang_random_unit, arang_random_unit
  end interface
  interface volume
     module procedure rang_volume
  end interface
  interface scalar_to_rang
     module procedure scalarr_to_rang, scalari_to_rang
  end interface
  interface isfinite
     module procedure  isfinite_rang, isfinite_arang
  end interface
contains
# 133


  function arang_t(a) result(r)
    real(r_kind), intent(in) :: a(:)
    type(rang_t) :: r(size(a))
    r%z = a  
  end function arang_t

  subroutine arang_equ_arang(a, b)
    type(rang_t), intent(in) :: b(:)
    type(rang_t), intent(out) :: a(size(b))
     a%z = b%z
  end subroutine arang_equ_arang
  function rang_eq_rang(a, b) result(r)
    type(rang_t), intent(in) :: a
    type(rang_t), intent(in) :: b
    logical :: r
    r =  a%z == b%z
  end function rang_eq_rang
  function arang_eq_arang(a, b) result(r)
    type(rang_t), intent(in) :: a(:)
    type(rang_t), intent(in) :: b(size(a))
    logical :: r(size(a))
    r =  a%z == b%z
  end function arang_eq_arang

  function rang_neq_rang(a, b) result(r)
    type(rang_t), intent(in) :: a
    type(rang_t), intent(in) :: b
    logical :: r
    r =  a%z /= b%z
  end function rang_neq_rang
  function arang_neq_arang(a, b) result(r)
    type(rang_t), intent(in) :: a(:)
    type(rang_t), intent(in) :: b(size(a))
    logical :: r(size(a))
    r =  a%z /= b%z
  end function arang_neq_arang
  function neg_rang(a)
    type(rang_t) neg_rang
    type(rang_t), intent(in):: a
     neg_rang%z = - a%z
  end function neg_rang
  function neg_arang(a)
    type(rang_t), intent(in):: a(:)
    type(rang_t) neg_arang(size(a))
     neg_arang%z = - a%z
  end function neg_arang

  function dot_rang_rang(a, b)
    real(r_kind) dot_rang_rang
    type(rang_t), intent(in):: a, b
    dot_rang_rang =  a%z*b%z
  end function dot_rang_rang
  function dot_arang_arang(a, b)
    type(rang_t), dimension (:), intent(in):: a, b
    real(r_kind), dimension(size(a)) :: dot_arang_arang
    dot_arang_arang =  a%z*b%z
  end function dot_arang_arang
  function dot_rang_arang(a, b)
    type(rang_t), dimension (:), intent(in):: b
    real(r_kind), dimension(size(b)) :: dot_rang_arang
    type(rang_t), intent(in):: a
    dot_rang_arang =  a%z*b%z
  end function dot_rang_arang
  function dot_arang_rang(a, b)
    type(rang_t), dimension (:), intent(in):: a
    real(r_kind), dimension(size(a)) :: dot_arang_rang
    type(rang_t), intent(in):: b
    dot_arang_rang =  a%z*b%z
  end function dot_arang_rang
  function div_rang_r(a, r)
    type(rang_t) div_rang_r
    type(rang_t), intent(in) :: a
    real(r_kind), intent(in) :: r
    div_rang_r%z = a%z/r
  end function div_rang_r
  function div_arang_r(a, r)
    type(rang_t), intent(in), dimension(:) :: a
    type(rang_t), dimension(size(a)) :: div_arang_r
    real(r_kind), intent(in) :: r
    div_arang_r%z = a%z/r
  end function div_arang_r
  function div_arang_ar(a, b) result(r)
    type(rang_t), intent(in) :: a(:)
    real(r_kind), intent(in) :: b(size(a))
    type(rang_t) :: r(size(a))
     r%z = a%z / b
  end function div_arang_ar
  function div_rang_i(a, r)
    type(rang_t) div_rang_i
    type(rang_t), intent(in) :: a
    integer, intent(in) :: r
    div_rang_i%z = a%z/r
  end function div_rang_i
  function div_arang_i(a, r)
    type(rang_t), intent(in) :: a(:)
    integer, intent(in) :: r
    type(rang_t) div_arang_i(size(a))
    div_arang_i%z = a%z/r
  end function div_arang_i
  function div_arang_ai(a, r)
    type(rang_t), intent(in) :: a(:)
    integer, intent(in) :: r(size(a))
    type(rang_t) div_arang_ai(size(a))
    div_arang_ai%z = a%z/r
  end function div_arang_ai

  function norm_rang(v)
    type(rang_t) ::norm_rang
    type(rang_t), intent(in) ::v
# 252


    norm_rang%z = sign(real(1, r_kind), v%z)

  end function norm_rang

! Metric functions
  function length_sqr_rang(a) result(r)
    real(r_kind) ::r
    type(rang_t), intent(in) ::a
    r = a%z**2
  end function length_sqr_rang
  function length_sqr_arang(a) result(r)
    type(rang_t), intent(in) ::a(:)
    real(r_kind) ::r(size(a))
    r = a%z**2
  end function length_sqr_arang
  function length_rang(a) result(r)
    type(rang_t), intent(in) ::a
    real(r_kind) :: r
    
    r = abs(a%z)
  end function length_rang
  function length_arang(a) result(r)
    type(rang_t), intent(in) ::a(:)
    real(r_kind) ::r(size(a))
    
    r = abs(a%z)
  end function length_arang

  function distance_rang(a, b) result(r)
    real(r_kind) :: r
    type(rang_t), intent(in) ::a, b
    
    r = abs(a%z - b%z)
  end function distance_rang
  function distance_sqr_rang(a, b) result(r)
    type(rang_t), intent(in) ::a, b
    real(r_kind) :: r
    r = (a%z - b%z)**2
  end function distance_sqr_rang
  function distance_arang(a, b) result(r)
    type(rang_t), intent(in) :: a(:), b(:)
    real(r_kind) :: r(size(a))
    
    r = abs(a%z - b%z)
  end function distance_arang
  function distance_sqr_arang(a, b) result(r)
    type(rang_t), intent(in) :: a(:), b(:)
    real(r_kind) :: r(size(a))
    r = (a%z - b%z)**2
  end function distance_sqr_arang

   function find_ang_rang(a, b)
    real(r_kind) :: find_ang_rang
    type(rang_t), intent(in) :: a, b
    real(r_kind) :: ab, d, x
    ab = a.dot.b; d = (a.dot.a)*(b.dot.b)
    if (d == 0.) then
       find_ang_rang = - 99999.
    else
       x = (ab/sqrt(d))
       if (abs(x)>1.) then
          write(*, *)'error in find_ang', x
          write(*, *)'a = ', a
          write(*, *)'b = ', b
          if (x< - 1.) x = - 1.
          if (x>1.) x = 1.
       endif
       find_ang_rang = acos(x)
    endif
  end function find_ang_rang
! Rrv + rang
  function rang_add_rang(a, b) result (r)
    type(rang_t), intent(in):: a
    type(rang_t), intent(in):: b
    type(rang_t) r
    r%z = a%z + b%z
  end function rang_add_rang
  function arang_add_rang(a, b) result (r)
    type(rang_t), intent(in):: a(:)
    type(rang_t), intent(in):: b
    type(rang_t) r(size(a))
    r%z = a%z + b%z
  end function arang_add_rang
  function rang_add_arang(a, b) result (r)
    type(rang_t), intent(in):: a
    type(rang_t), intent(in):: b(:)
    type(rang_t) r(size(b))
    r%z = a%z + b%z
  end function rang_add_arang
  function arang_add_arang(a, b) result (r)
    type(rang_t), intent(in):: a(:)
    type(rang_t), intent(in):: b(size(a))
    type(rang_t) r(size(a))
    r%z = a%z + b%z
  end function arang_add_arang
! Rrv - rang
  function rang_sub_rang(a, b) result (r)
    type(rang_t), intent(in):: a
    type(rang_t), intent(in):: b
    type(rang_t) r
    r%z = a%z - b%z
  end function rang_sub_rang
  function arang_sub_rang(a, b) result (r)
    type(rang_t), intent(in):: a(:)
    type(rang_t), intent(in):: b
    type(rang_t) r(size(a))
    r%z = a%z - b%z
  end function arang_sub_rang
  function rang_sub_arang(a, b) result (r)
    type(rang_t), intent(in):: a
    type(rang_t), intent(in):: b(:)
    type(rang_t) r(size(b))
    r%z = a%z - b%z
  end function rang_sub_arang
  function arang_sub_arang(a, b) result (r)
    type(rang_t), intent(in):: a(:)
    type(rang_t), intent(in):: b(size(a))
    type(rang_t) r(size(a))
    r%z = a%z - b%z
  end function arang_sub_arang
! real times real vectors
  function r_mult_rang(a, b) result(r)
    real(r_kind), intent(in) :: a
    type(rang_t), intent(in) :: b
    type(rang_t) r
     r%z = a * b%z
  end function r_mult_rang
  function rang_mult_r(a, b) result(r)
    type(rang_t), intent(in) :: a
    real(r_kind), intent(in) :: b
    type(rang_t) r
     r%z = a%z * b
  end function rang_mult_r
  function r_mult_arang(a, b) result(r)
    real(r_kind), intent(in) :: a
    type(rang_t), intent(in) :: b(:)
    type(rang_t) r(size(b))
     r%z = a * b%z
  end function r_mult_arang
  function arang_mult_r(a, b) result(r)
    type(rang_t), intent(in) :: a(:)
    real(r_kind), intent(in) :: b
    type(rang_t) r(size(a))
     r%z = a%z * b
  end function arang_mult_r

! integer times real vectors
  function i_mult_rang(a, b) result(r)
    integer, intent(in) :: a
    type(rang_t), intent(in) :: b
    type(rang_t) r
     r%z = a * b%z
  end function i_mult_rang
  function rang_mult_i(a, b) result(r)
    type(rang_t), intent(in) :: a
    integer, intent(in) :: b
    type(rang_t) r
     r%z = a%z * b
  end function rang_mult_i
  function i_mult_arang(a, b) result(r)
    integer, intent(in) :: a
    type(rang_t), intent(in) :: b(:)
    type(rang_t) r(size(b))
     r%z = a * b%z
  end function i_mult_arang
  function arang_mult_i(a, b) result(r)
    type(rang_t), intent(in) :: a(:)
    integer, intent(in) :: b
    type(rang_t) r(size(a))
    r%z = a%z * b
  end function arang_mult_i
! Vectors times arrays of integers or reals
! real times real vectors
  function ar_mult_rang(a, b) result(r)
    real(r_kind), intent(in) :: a(:)
    type(rang_t), intent(in) :: b
    type(rang_t) r(size(a))
    r%z = a * b%z
  end function ar_mult_rang
  function rang_mult_ar(a, b) result(r)
    type(rang_t), intent(in) :: a
    real(r_kind), intent(in) :: b(:)
    type(rang_t) r(size(b))
     r%z = a%z * b
  end function rang_mult_ar
  function ar_mult_arang(a, b) result(r)
    real(r_kind), intent(in) :: a(:)
    type(rang_t), intent(in) :: b(size(a))
    type(rang_t) r(size(a))
     r%z = a * b%z
  end function ar_mult_arang
  function arang_mult_ar(a, b) result(r)
    type(rang_t), intent(in) :: a(:)
    real(r_kind), intent(in) :: b(size(a))
    type(rang_t) r(size(a))
     r%z = a%z * b
  end function arang_mult_ar

! integer times real vectors
  function ai_mult_rang(a, b) result(r)
    integer, intent(in) :: a(:)
    type(rang_t), intent(in) :: b
    type(rang_t) r(size(a))
    r%z = a * b%z
  end function ai_mult_rang
  function rang_mult_ai(a, b) result(r)
    type(rang_t), intent(in) :: a
    integer, intent(in) :: b(:)
    type(rang_t) r(size(b))
    r%z = a%z * b
  end function rang_mult_ai
  function ai_mult_arang(a, b) result(r)
    integer, intent(in) :: a(:)
    type(rang_t), intent(in) :: b(size(a))
    type(rang_t) r(size(a))
    r%z = a * b%z
  end function ai_mult_arang
  function arang_mult_ai(a, b) result(r)
    type(rang_t), intent(in) :: a(:)
    integer, intent(in) :: b(size(a))
    type(rang_t) r(size(a))
    r%z = a%z * b
  end function arang_mult_ai
! Comparison functions, less than, greater than
! returns true if all the elements of each vector are < (or >)
! Defined for real(r_kind) 3 vectors arrays and scalars
! First for real(r_kind)s
  function le_rang_rang(r, s) ! Scalar vectors
    logical :: le_rang_rang
    type(rang_t), intent(in) :: r, s
    le_rang_rang =  r%z<s%z 
  end function le_rang_rang
  function le_arang_rang(r, s) ! r is array s is scalar
    type(rang_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: le_arang_rang
    type(rang_t), intent(in) :: s
    le_arang_rang =  r%z<s%z 
  end function le_arang_rang
  function le_rang_arang(r, s) ! s is array r is scalar
    type(rang_t), intent(in), dimension(:) :: s
    logical, dimension(size(s)) :: le_rang_arang
    type(rang_t), intent(in) :: r
    le_rang_arang =  r%z<s%z 
  end function le_rang_arang
  function le_arang_arang(r, s) ! r is array s is scalar
    type(rang_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: le_arang_arang
    type(rang_t), intent(in), dimension(size(r)) :: s
    le_arang_arang =  r%z<s%z 
  end function le_arang_arang

! Greater than function
  function ge_rang_rang(r, s) ! Scalar vectors
    logical :: ge_rang_rang
    type(rang_t), intent(in) :: r, s
    ge_rang_rang =  r%z>s%z 
  end function ge_rang_rang
  function ge_arang_rang(r, s) ! r is array s is scalar
    type(rang_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: ge_arang_rang
    type(rang_t), intent(in) :: s
    ge_arang_rang =  r%z>s%z 
  end function ge_arang_rang
  function ge_rang_arang(r, s) ! s is array r is scalar
    type(rang_t), intent(in), dimension(:) :: s
    logical, dimension(size(s)) :: ge_rang_arang
    type(rang_t), intent(in) :: r
    ge_rang_arang =  r%z>s%z 
  end function ge_rang_arang
  function ge_arang_arang(r, s) ! r is array s is scalar
    type(rang_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: ge_arang_arang
    type(rang_t), intent(in), dimension(size(r)) :: s
    ge_arang_arang =  r%z>s%z 
  end function ge_arang_arang


! Comparison functions, less than, greater than
! returns true if all the elements of each vector are < = (or > =)
! Defined for real(r_kind) 3 vectors arrays and scalars
! First for real(r_kind)s
  function leq_rang_rang(r, s) ! Scalar vectors
    logical :: leq_rang_rang
    type(rang_t), intent(in) :: r, s
    leq_rang_rang =  r%z <= s%z 
  end function leq_rang_rang
  function leq_arang_rang(r, s) ! r is array s is scalar
    type(rang_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: leq_arang_rang
    type(rang_t), intent(in) :: s
    leq_arang_rang =  r%z <= s%z 
  end function leq_arang_rang
  function leq_rang_arang(r, s) ! s is array r is scalar
    type(rang_t), intent(in), dimension(:) :: s
    logical, dimension(size(s)) :: leq_rang_arang
    type(rang_t), intent(in) :: r
    leq_rang_arang =  r%z <= s%z 
  end function leq_rang_arang
  function leq_arang_arang(r, s) ! r is array s is scalar
    type(rang_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: leq_arang_arang
    type(rang_t), intent(in), dimension(size(r)) :: s
    leq_arang_arang =  r%z <= s%z 
  end function leq_arang_arang

! Greater than function
  function geq_rang_rang(r, s) ! Scalar vectors
    logical :: geq_rang_rang
    type(rang_t), intent(in) :: r, s
    geq_rang_rang =  r%z >= s%z 
  end function geq_rang_rang
  function geq_arang_rang(r, s) ! r is array s is scalar
    type(rang_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: geq_arang_rang
    type(rang_t), intent(in) :: s
    geq_arang_rang =  r%z >= s%z 
  end function geq_arang_rang
  function geq_rang_arang(r, s) ! s is array r is scalar
    type(rang_t), intent(in), dimension(:) :: s
    logical, dimension(size(s)) :: geq_rang_arang
    type(rang_t), intent(in) :: r
    geq_rang_arang =  r%z >= s%z 
  end function geq_rang_arang
  function geq_arang_arang(r, s) ! r is array s is scalar
    type(rang_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: geq_arang_arang
    type(rang_t), intent(in), dimension(size(r)) :: s
    geq_arang_arang =  r%z >= s%z 
  end function geq_arang_arang

! Maximum Minimum and Sum functions
  function sum_arang(a) result(r)
    type(rang_t), intent(in) :: a(:)
    type(rang_t) :: r
    r%z = sum(a%z)
  end function sum_arang

  function minval_arang(a) result(r)
    type(rang_t) :: r
    type(rang_t), intent(in) :: a(:)
    r%z = minval(a%z)
  end function minval_arang
  function maxval_arang(a) result(r)
    type(rang_t) :: r
    type(rang_t), intent(in) :: a(:)
    r%z = maxval(a%z)
  end function maxval_arang
  function min_rang(a, b) result(r)
    type(rang_t) :: r
    type(rang_t), intent(in) :: a, b
    r%z = min(a%z, b%z)
  end function min_rang
  function max_rang(a, b) result(r)
    type(rang_t) :: r
    type(rang_t), intent(in) :: a, b
    r%z = max(a%z, b%z)
  end function max_rang
  subroutine rang_random_number(a)
    type(rang_t), intent(out) :: a
    
    
    call random_number(a%z) 
  end subroutine rang_random_number
  subroutine arang_random_number(a)
    type(rang_t), intent(out) :: a(:)
    
    
    call random_number(a%z)
  end subroutine arang_random_number

! Return a random unit vectors
  subroutine rang_random_unit(a)
    type(rang_t), intent(out) :: a
    real(r_kind) l
    do
       call random_number(a)
       a = a - rang_t(.5)
       l = length_sqr(a)
       if (l < .5**2) exit
    end do
    a = a/sqrt(l)
  end subroutine rang_random_unit
! Return an array of random unit vectors
  subroutine arang_random_unit(a)
    type(rang_t), intent(out) :: a(:)
    integer i
    do i = 1, size(a)
       call random_unit_vector(a(i))
    end do
  end subroutine arang_random_unit

  subroutine arang_stats(v, minv, maxv, meanv)
    type(rang_t), intent(in) :: v(:)
    type(rang_t), intent(out) :: minv, maxv, meanv
    minv = minval(v)
    maxv = maxval(v)
    meanv = sum(v)/size(v)
  end subroutine arang_stats
  function rang_volume(a)
    type(rang_t), intent(in) :: a
    integer :: rang_volume
    rang_volume = a%z
  end function rang_volume
  function scalarr_to_rang(a) result (r)
    real(r_kind), intent(in) :: a
    type(rang_t) r
    r = rang_t(a)
  end function scalarr_to_rang
  function scalari_to_rang(a) result (r)
    integer, intent(in) :: a
    type(rang_t) r
    r = scalarr_to_rang(real(a, r_kind))
  end function scalari_to_rang
  function isfinite_rang(a) result(r)
    type(rang_t), intent(in) :: a
    logical r
    r =  isfinite(a%z)
  end function isfinite_rang
  function isfinite_arang(a) result(r)
    type(rang_t), intent(in) :: a(:)
    logical r
    r =  isfinite(a%z)
  end function isfinite_arang
end module rang_f90_def


