# 1 "rvec_f90_def.F90"
# 1 "/home/jim/fortran/library/dimension.h" 1 
!Define preprocessor macros that define the dimension
!Default is Three dimensions
!Overide by compiling with -DTWODIM or defining 1 before this is included
!If the file is directly edited then the dependencies will cause the correct files
!to be recompiled so this is probably best
 
# 11


! Commands only for three dimensions use the macro CMD3() 
# 20


! Commands only for two dimensions use the macro CMD2()








# 2 "/home/jim/fortran/library/rvec_f90_def.F90" 2 
module rvec_f90_def
  use precision
  implicit none
  type, public :: rvec_t  ! Real(R_kind) vector
     real(r_kind) x
     real(r_kind) y
     
  end type rvec_t

  type(rvec_t), parameter :: null_rvec = rvec_t(0,0) !SR2201BUG
!  type(rvec_t) :: null_rvec = rvec_t(0,0)

  interface assignment(=)
     module procedure arvec_equ_arvec
  end interface
  interface operator(==)
     module procedure rvec_eq_rvec, arvec_eq_arvec
  end interface
  interface operator(/=)
     module procedure rvec_neq_rvec, arvec_neq_arvec
  end interface
  interface operator(<) 
     module procedure le_rvec_rvec, le_rvec_arvec, le_arvec_rvec, le_arvec_arvec
  end interface
  interface operator(>) 
     module procedure ge_rvec_rvec, ge_rvec_arvec, ge_arvec_rvec, ge_arvec_arvec
  end interface
  interface operator(<=) 
     module procedure leq_rvec_rvec, leq_rvec_arvec, leq_arvec_rvec, leq_arvec_arvec
  end interface
  interface operator(>=) 
     module procedure geq_rvec_rvec, geq_rvec_arvec, geq_arvec_rvec, geq_arvec_arvec
  end interface
  interface operator(+)
     module procedure  &
          rvec_add_rvec, arvec_add_arvec, rvec_add_arvec, arvec_add_rvec
  end interface
  interface operator(-)
     module procedure  neg_rvec,  neg_arvec,  &
          rvec_sub_rvec, arvec_sub_arvec, rvec_sub_arvec, arvec_sub_rvec
  end interface
  interface operator(*)
     module procedure  &
          rvec_mult_r, r_mult_rvec, arvec_mult_r, r_mult_arvec, &
          rvec_mult_i, i_mult_rvec, arvec_mult_i, i_mult_arvec, &
          rvec_mult_ar, ar_mult_rvec, arvec_mult_ar, ar_mult_arvec, &
          rvec_mult_ai, ai_mult_rvec, arvec_mult_ai, ai_mult_arvec
  end interface
  interface operator(/)
     module procedure div_rvec_r, div_arvec_r, div_arvec_ar, &
          div_rvec_i, div_arvec_i, div_arvec_ai 
  end interface
  interface operator(.dot.)
     module procedure dot_rvec_rvec, dot_arvec_arvec, dot_rvec_arvec, dot_arvec_rvec
  end interface
  interface length
     module procedure length_rvec, length_arvec
  end interface
  interface length_sqr
     module procedure length_sqr_rvec, length_sqr_arvec
  end interface
  interface distance
     module procedure distance_rvec, distance_arvec
  end interface
  interface distance_sqr
     module procedure distance_sqr_rvec, distance_sqr_arvec
  end interface
  interface sum
     module procedure sum_arvec
  end interface
  interface minval
     module procedure minval_arvec
  end interface
  interface maxval
     module procedure maxval_arvec
  end interface
  interface max
     module procedure max_rvec
  end interface
  interface min
     module procedure min_rvec
  end interface
  interface random_number
     module procedure rvec_random_number, arvec_random_number
  end interface
  interface stats
     module procedure arvec_stats
  end interface
  interface random_unit_vector
     module procedure rvec_random_unit, arvec_random_unit
  end interface
  interface volume
     module procedure  rvec_volume
  end interface
  interface scalar_to_rvec
     module procedure  scalarr_to_rvec, scalari_to_rvec
  end interface
  interface isfinite
     module procedure  isfinite_rvec, isfinite_arvec
  end interface
  interface rvec
     module procedure  rvec_ta
  end interface
  
contains
  function rvec_ta(a,b) result(r)
    real(r_kind),      intent(in) :: a(:)
    real(r_kind),      intent(in) :: b(size(a))
# 112

    type(rvec_t) r(size(a))
    r%x=a
    r%y=b
    
  end function rvec_ta
  subroutine arvec_equ_arvec(a,b)
    type(rvec_t),intent(in) :: b(:)
    type(rvec_t),intent(out) :: a(size(b))
    a%x=b%x; a%y=b%y;  
  end subroutine arvec_equ_arvec
  function rvec_eq_rvec(a,b) result(r)
    type(rvec_t),intent(in) :: a
    type(rvec_t),intent(in) :: b
    logical              :: r
    r = a%x==b%x .and. a%y==b%y 
  end function rvec_eq_rvec
  function arvec_eq_arvec(a,b) result(r)
    type(rvec_t),intent(in) :: a(:)
    type(rvec_t),intent(in) :: b(size(a))
    logical              :: r(size(a))
    r = a%x==b%x .and. a%y==b%y 
  end function arvec_eq_arvec

  function rvec_neq_rvec(a,b) result(r)
    type(rvec_t),intent(in) :: a
    type(rvec_t),intent(in) :: b
    logical              :: r
    r = a%x/=b%x .and. a%y/=b%y 
  end function rvec_neq_rvec
  function arvec_neq_arvec(a,b) result(r)
    type(rvec_t),intent(in) :: a(:)
    type(rvec_t),intent(in) :: b(size(a))
    logical              :: r(size(a))
    r = a%x/=b%x .and. a%y/=b%y 
  end function arvec_neq_arvec
  function neg_rvec(a)
    type(rvec_t) neg_rvec
    type(rvec_t) , intent(in):: a
    neg_rvec%x = -a%x;  neg_rvec%y = -a%y;  
  end function neg_rvec
  function neg_arvec(a)
    type(rvec_t) , intent(in):: a(:)
    type(rvec_t) neg_arvec(size(a))
    neg_arvec%x = -a%x;  neg_arvec%y = -a%y;  
  end function neg_arvec

  function dot_rvec_rvec(a,b)
    real(r_kind)      dot_rvec_rvec
    type(rvec_t) , intent(in):: a,b
    dot_rvec_rvec = a%x*b%x + a%y*b%y 
  end function dot_rvec_rvec
  function dot_arvec_arvec(a,b)
    type(rvec_t), dimension (:), intent(in):: a,b
    real(r_kind), dimension(size(a)) :: dot_arvec_arvec
    dot_arvec_arvec = a%x*b%x + a%y*b%y 
  end function dot_arvec_arvec
  function dot_rvec_arvec(a,b)
    type(rvec_t), dimension (:), intent(in):: b
    real(r_kind), dimension(size(b)) :: dot_rvec_arvec
    type(rvec_t), intent(in):: a
    dot_rvec_arvec = a%x*b%x + a%y*b%y 
  end function dot_rvec_arvec
  function dot_arvec_rvec(a,b)
    type(rvec_t), dimension (:), intent(in):: a
    real(r_kind), dimension(size(a)) :: dot_arvec_rvec
    type(rvec_t), intent(in):: b
    dot_arvec_rvec = a%x*b%x + a%y*b%y 
  end function dot_arvec_rvec
  function div_rvec_r(a,r)
    type(rvec_t) div_rvec_r
    type(rvec_t) , intent(in) :: a
    real(r_kind)      , intent(in) :: r
    div_rvec_r%x = a%x/r;div_rvec_r%y = a%y/r;
  end function div_rvec_r
  function div_arvec_r(a,r)
    type(rvec_t) , intent(in),dimension(:) :: a
    type(rvec_t),dimension(size(a)) :: div_arvec_r
    real(r_kind)      , intent(in) :: r
    div_arvec_r%x = a%x/r;div_arvec_r%y=a%y/r;
  end function div_arvec_r
  function div_arvec_ar(a,b) result(r)
    type(rvec_t), intent(in)    :: a(:)
    real(r_kind), intent(in) :: b(size(a))
    type(rvec_t)                :: r(size(a))
    r%x = a%x / b; r%y = a%y / b; 
  end function div_arvec_ar
  function div_rvec_i(a,r)
    type(rvec_t) div_rvec_i
    type(rvec_t) , intent(in) :: a
    integer      , intent(in) :: r
    div_rvec_i%x=a%x/r;div_rvec_i%y=a%y/r;
  end function div_rvec_i
  function div_arvec_i(a,r)
    type(rvec_t) , intent(in) :: a(:)
    integer      , intent(in) :: r
    type(rvec_t) div_arvec_i(size(a))
    div_arvec_i%x = a%x/r;div_arvec_i%y=a%y/r;
  end function div_arvec_i
  function div_arvec_ai(a,r)
    type(rvec_t) , intent(in) :: a(:)
    integer      , intent(in) :: r(size(a))
    type(rvec_t) div_arvec_ai(size(a))
    div_arvec_ai%x=a%x/r;div_arvec_ai%y=a%y/r;
  end function div_arvec_ai

  function norm_rvec(v)
    type(rvec_t)              ::norm_rvec
    type(rvec_t),intent(in)   ::v
    real(r_kind) :: n
    n  = sqrt(v.dot.v)
    if (n>0) then
       norm_rvec%x = v%x/n
       norm_rvec%y = v%y/n
       
    endif
  end  function norm_rvec

! Metric functions
  function length_sqr_rvec(a) result(r)
    real(r_kind)            ::r
    type(rvec_t),intent(in)   ::a
    r = a%x**2+a%y**2 
  end  function length_sqr_rvec
  function length_sqr_arvec(a) result(r)
    type(rvec_t),intent(in) ::a(:)
    real(r_kind)          ::r(size(a))
    r = a%x**2+a%y**2 
  end  function length_sqr_arvec
  function length_rvec(a) result(r)
    type(rvec_t),intent(in)   ::a
    real(r_kind)             :: r
    r = sqrt(a%x**2+a%y**2 )
  end  function length_rvec
  function length_arvec(a) result(r)
    type(rvec_t),intent(in) ::a(:)
    real(r_kind)          ::r(size(a))
    r = sqrt(a%x**2+a%y**2 )
  end  function length_arvec


  function distance_rvec(a,b) result(r)
    real(r_kind)            :: r
    type(rvec_t),intent(in)   ::a,b
    r = sqrt((a%x-b%x)**2+(a%y-b%y)**2 )
  end  function distance_rvec
  function distance_sqr_rvec(a,b) result(r)
    type(rvec_t),intent(in) ::a,b
    real(r_kind)          :: r
    r = (a%x-b%x)**2+(a%y-b%y)**2 
  end  function distance_sqr_rvec
  function distance_arvec(a,b) result(r)
    type(rvec_t),intent(in)   :: a(:),b(:)
    real(r_kind)            :: r(size(a))
    r = sqrt((a%x-b%x)**2+(a%y-b%y)**2 )
  end  function distance_arvec
  function distance_sqr_arvec(a,b) result(r)
    type(rvec_t),intent(in) :: a(:),b(:)
    real(r_kind)          :: r(size(a))
    r = (a%x-b%x)**2+(a%y-b%y)**2 
  end  function distance_sqr_arvec

!-------------------------------------- angles
  function find_ang_rvec(a,b)
    real(r_kind)             :: find_ang_rvec
    type(rvec_t), intent(in)  :: a,b
    real(r_kind)             :: ab,d,x
    ab = a.dot.b;   d = (a.dot.a)*(b.dot.b)
    if (d==0.) then
       find_ang_rvec = -99999.
    else
       x = (ab/sqrt(d))
       if (abs(x)>1.) then
          write(*,*)'error in find_ang', x
          write(*,*)'a=',a
          write(*,*)'b=',b
          if (x<-1.) x = -1.
          if (x>1.)  x = 1.
       endif
       find_ang_rvec = acos(x)
    endif
  end function find_ang_rvec
! Rrv + rvec
  function rvec_add_rvec(a,b) result (r)
    type(rvec_t) , intent(in):: a
    type(rvec_t) , intent(in):: b
    type(rvec_t) r
    r%x = a%x + b%x;  r%y = a%y + b%y;  
  end function rvec_add_rvec
  function arvec_add_rvec(a,b) result (r)
    type(rvec_t) , intent(in):: a(:)
    type(rvec_t) , intent(in):: b
    type(rvec_t) r(size(a))
    r%x = a%x + b%x;  r%y = a%y + b%y;  
  end function arvec_add_rvec
  function rvec_add_arvec(a,b) result (r)
    type(rvec_t) , intent(in):: a
    type(rvec_t) , intent(in):: b(:)
    type(rvec_t) r(size(b))
    r%x = a%x + b%x;  r%y = a%y + b%y;  
  end function rvec_add_arvec
  function arvec_add_arvec(a,b) result (r)
    type(rvec_t) , intent(in):: a(:)
    type(rvec_t) , intent(in):: b(size(a))
    type(rvec_t) r(size(a))
    r%x = a%x + b%x;  r%y = a%y + b%y;  
  end function arvec_add_arvec
! Rrv - rvec
  function rvec_sub_rvec(a,b) result (r)
    type(rvec_t) , intent(in):: a
    type(rvec_t) , intent(in):: b
    type(rvec_t) r
    r%x = a%x - b%x;  r%y = a%y - b%y;  
  end function rvec_sub_rvec
  function arvec_sub_rvec(a,b) result (r)
    type(rvec_t) , intent(in):: a(:)
    type(rvec_t) , intent(in):: b
    type(rvec_t) r(size(a))
    r%x = a%x - b%x;  r%y = a%y - b%y;  
  end function arvec_sub_rvec
  function rvec_sub_arvec(a,b) result (r)
    type(rvec_t) , intent(in):: a
    type(rvec_t) , intent(in):: b(:)
    type(rvec_t) r(size(b))
    r%x = a%x - b%x;  r%y = a%y - b%y;  
  end function rvec_sub_arvec
  function arvec_sub_arvec(a,b) result (r)
    type(rvec_t) , intent(in):: a(:)
    type(rvec_t) , intent(in):: b(size(a))
    type(rvec_t) r(size(a))
    r%x = a%x - b%x;  r%y = a%y - b%y;  
  end function arvec_sub_arvec
! real times real vectors
  function r_mult_rvec(a,b) result(r)
    real(r_kind), intent(in) :: a
    type(rvec_t), intent(in)    :: b
    type(rvec_t) r
    r%x = a * b%x;  r%y = a * b%y; 
  end function r_mult_rvec
  function rvec_mult_r(a,b) result(r)
    type(rvec_t), intent(in)    :: a
    real(r_kind), intent(in) :: b
    type(rvec_t) r
    r%x = a%x * b;  r%y = a%y * b; 
  end function rvec_mult_r
  function r_mult_arvec(a,b) result(r)
    real(r_kind), intent(in) :: a
    type(rvec_t), intent(in)    :: b(:)
    type(rvec_t) r(size(b))
    r%x = a * b%x;  r%y = a * b%y; 
  end function r_mult_arvec
  function arvec_mult_r(a,b) result(r)
    type(rvec_t), intent(in)    :: a(:)
    real(r_kind), intent(in) :: b
    type(rvec_t) r(size(a))
    r%x = a%x * b;  r%y = a%y * b; 
  end function arvec_mult_r

! integer times real vectors
  function i_mult_rvec(a,b) result(r)
    integer, intent(in) :: a
    type(rvec_t), intent(in)    :: b
    type(rvec_t) r
    r%x = a * b%x;  r%y = a * b%y; 
  end function i_mult_rvec
  function rvec_mult_i(a,b) result(r)
    type(rvec_t), intent(in)    :: a
    integer, intent(in) :: b
    type(rvec_t) r
    r%x = a%x * b;  r%y = a%y * b; 
  end function rvec_mult_i
  function i_mult_arvec(a,b) result(r)
    integer, intent(in) :: a
    type(rvec_t), intent(in)    :: b(:)
    type(rvec_t) r(size(b))
    r%x = a * b%x;  r%y = a * b%y; 
  end function i_mult_arvec
  function arvec_mult_i(a,b) result(r)
    type(rvec_t), intent(in)    :: a(:)
    integer, intent(in) :: b
    type(rvec_t) r(size(a))
    r%x = a%x * b;  r%y = a%y * b; 
  end function arvec_mult_i
! Vectors times arrays of integers or reals
! real times real vectors
  function ar_mult_rvec(a,b) result(r)
    real(r_kind), intent(in) :: a(:)
    type(rvec_t), intent(in)    :: b
    type(rvec_t) r(size(a))
    r%x = a * b%x;  r%y = a * b%y; 
  end function ar_mult_rvec
  function rvec_mult_ar(a,b) result(r)
    type(rvec_t), intent(in)    :: a
    real(r_kind), intent(in) :: b(:)
    type(rvec_t) r(size(b))
    r%x = a%x * b;  r%y = a%y * b; 
  end function rvec_mult_ar
  function ar_mult_arvec(a,b) result(r)
    real(r_kind), intent(in) :: a(:)
    type(rvec_t), intent(in)    :: b(size(a))
    type(rvec_t) r(size(a))
    r%x = a * b%x;  r%y = a * b%y; 
  end function ar_mult_arvec
  function arvec_mult_ar(a,b) result(r)
    type(rvec_t), intent(in)    :: a(:)
    real(r_kind), intent(in) :: b(size(a))
    type(rvec_t) r(size(a))
    r%x = a%x * b;  r%y = a%y * b; 
  end function arvec_mult_ar

! integer times real vectors
  function ai_mult_rvec(a,b) result(r)
    integer, intent(in) :: a(:)
    type(rvec_t), intent(in)    :: b
    type(rvec_t) r(size(a))
    r%x = a * b%x;  r%y = a * b%y; 
  end function ai_mult_rvec
  function rvec_mult_ai(a,b) result(r)
    type(rvec_t), intent(in)    :: a
    integer, intent(in) :: b(:)
    type(rvec_t) r(size(b))
    r%x = a%x * b;  r%y = a%y * b; 
  end function rvec_mult_ai
  function ai_mult_arvec(a,b) result(r)
    integer, intent(in) :: a(:)
    type(rvec_t), intent(in)    :: b(size(a))
    type(rvec_t) r(size(a))
    r%x = a * b%x;  r%y = a * b%y; 
  end function ai_mult_arvec
  function arvec_mult_ai(a,b) result(r)
    type(rvec_t), intent(in)    :: a(:)
    integer, intent(in) :: b(size(a))
    type(rvec_t) r(size(a))
    r%x = a%x * b;  r%y = a%y * b; 
  end function arvec_mult_ai
! Comparison functions, less than, greater than
! returns true if all the elements of each vector are < (or >)
! Defined for real(r_kind) 3 vectors arrays and scalars
! First for real(r_kind)s
  function le_rvec_rvec(r,s) ! Scalar vectors
    logical :: le_rvec_rvec
    type(rvec_t), intent(in) :: r,s
    le_rvec_rvec = r%x<s%x .and. r%y<s%y  
  end function le_rvec_rvec
  function le_arvec_rvec(r,s) ! r is array s is scalar
    type(rvec_t), intent(in),dimension(:) :: r
    logical, dimension(size(r)) :: le_arvec_rvec
    type(rvec_t), intent(in) :: s
    le_arvec_rvec = r%x<s%x .and. r%y<s%y  
  end function le_arvec_rvec
  function le_rvec_arvec(r,s) ! s is array r is scalar
    type(rvec_t), intent(in),dimension(:) :: s
    logical, dimension(size(s)) :: le_rvec_arvec
    type(rvec_t), intent(in) :: r
    le_rvec_arvec = r%x<s%x .and. r%y<s%y  
  end function le_rvec_arvec
  function le_arvec_arvec(r,s) ! r is array s is scalar
    type(rvec_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: le_arvec_arvec
    type(rvec_t), intent(in), dimension(size(r)) :: s
    le_arvec_arvec = r%x<s%x .and. r%y<s%y  
  end function le_arvec_arvec

! Greater than function
  function ge_rvec_rvec(r,s) ! Scalar vectors
    logical :: ge_rvec_rvec
    type(rvec_t), intent(in) :: r,s
    ge_rvec_rvec = r%x>s%x .and. r%y>s%y  
  end function ge_rvec_rvec
  function ge_arvec_rvec(r,s) ! r is array s is scalar
    type(rvec_t), intent(in),dimension(:) :: r
    logical, dimension(size(r)) :: ge_arvec_rvec
    type(rvec_t), intent(in) :: s
    ge_arvec_rvec = r%x>s%x .and. r%y>s%y  
  end function ge_arvec_rvec
  function ge_rvec_arvec(r,s) ! s is array r is scalar
    type(rvec_t), intent(in),dimension(:) :: s
    logical, dimension(size(s)) :: ge_rvec_arvec
    type(rvec_t), intent(in) :: r
    ge_rvec_arvec = r%x>s%x .and. r%y>s%y  
  end function ge_rvec_arvec
  function ge_arvec_arvec(r,s) ! r is array s is scalar
    type(rvec_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: ge_arvec_arvec
    type(rvec_t), intent(in), dimension(size(r)) :: s
    ge_arvec_arvec = r%x>s%x .and. r%y>s%y  
  end function ge_arvec_arvec


! Comparison functions, less than, greater than
! returns true if all the elements of each vector are <= (or >=)
! Defined for real(r_kind) 3 vectors arrays and scalars
! First for real(r_kind)s
  function leq_rvec_rvec(r,s) ! Scalar vectors
    logical :: leq_rvec_rvec
    type(rvec_t), intent(in) :: r,s
    leq_rvec_rvec = r%x<=s%x .and. r%y<=s%y  
  end function leq_rvec_rvec
  function leq_arvec_rvec(r,s) ! r is array s is scalar
    type(rvec_t), intent(in),dimension(:) :: r
    logical, dimension(size(r)) :: leq_arvec_rvec
    type(rvec_t), intent(in) :: s
    leq_arvec_rvec = r%x<=s%x .and. r%y<=s%y  
  end function leq_arvec_rvec
  function leq_rvec_arvec(r,s) ! s is array r is scalar
    type(rvec_t), intent(in),dimension(:) :: s
    logical, dimension(size(s)) :: leq_rvec_arvec
    type(rvec_t), intent(in) :: r
    leq_rvec_arvec = r%x<=s%x .and. r%y<=s%y  
  end function leq_rvec_arvec
  function leq_arvec_arvec(r,s) ! r is array s is scalar
    type(rvec_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: leq_arvec_arvec
    type(rvec_t), intent(in), dimension(size(r)) :: s
    leq_arvec_arvec = r%x<=s%x .and. r%y<=s%y  
  end function leq_arvec_arvec

! Greater than function
  function geq_rvec_rvec(r,s) ! Scalar vectors
    logical :: geq_rvec_rvec
    type(rvec_t), intent(in) :: r,s
    geq_rvec_rvec = r%x>=s%x .and. r%y>=s%y  
  end function geq_rvec_rvec
  function geq_arvec_rvec(r,s) ! r is array s is scalar
    type(rvec_t), intent(in),dimension(:) :: r
    logical, dimension(size(r)) :: geq_arvec_rvec
    type(rvec_t), intent(in) :: s
    geq_arvec_rvec = r%x>=s%x .and. r%y>=s%y  
  end function geq_arvec_rvec
  function geq_rvec_arvec(r,s) ! s is array r is scalar
    type(rvec_t), intent(in),dimension(:) :: s
    logical, dimension(size(s)) :: geq_rvec_arvec
    type(rvec_t), intent(in) :: r
    geq_rvec_arvec = r%x>=s%x .and. r%y>=s%y  
  end function geq_rvec_arvec
  function geq_arvec_arvec(r,s) ! r is array s is scalar
    type(rvec_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: geq_arvec_arvec
    type(rvec_t), intent(in), dimension(size(r)) :: s
    geq_arvec_arvec = r%x>=s%x .and. r%y>=s%y  
  end function geq_arvec_arvec



! Maximum Minimum and Sum functions
  function sum_arvec(a) result(r)
    type(rvec_t),intent(in) :: a(:)
    type(rvec_t) :: r
    r%x = sum(a%x);r%y = sum(a%y);
  end function sum_arvec

  function minval_arvec(a) result(r)
    type(rvec_t) :: r
    type(rvec_t),intent(in) :: a(:)
    r%x = minval(a%x);r%y = minval(a%y);
  end function minval_arvec
  function maxval_arvec(a) result(r)
    type(rvec_t) :: r
    type(rvec_t),intent(in) :: a(:)
    r%x = maxval(a%x);r%y = maxval(a%y);
  end function maxval_arvec
  function min_rvec(a,b) result(r)
    type(rvec_t) :: r
    type(rvec_t),intent(in) :: a,b
    r%x = min(a%x,b%x);r%y = min(a%y,b%y);
  end function min_rvec
  function max_rvec(a,b) result(r)
    type(rvec_t) :: r
    type(rvec_t),intent(in) :: a,b
    r%x = max(a%x,b%x);r%y = max(a%y,b%y);
  end function max_rvec
  subroutine rvec_random_number(a)
    type(rvec_t),intent(out) :: a
    call random_number(a%x)
    call random_number(a%y)
       
  end subroutine rvec_random_number
  subroutine arvec_random_number(a)
    type(rvec_t),intent(out) :: a(:)
    call random_number(a%x)
    call random_number(a%y)
    
  end subroutine arvec_random_number

! Return a random unit vectors
  subroutine rvec_random_unit(a)
    type(rvec_t),intent(out) :: a
    real(r_kind) l
    do
       call random_number(a)
       a = a-rvec_t(.5,.5)
       l = length_sqr(a)
       if (l < .5**2) exit
    end do
    a = a/sqrt(l)
  end subroutine rvec_random_unit
! Return an array of random unit vectors
  subroutine arvec_random_unit(a)
    type(rvec_t),intent(out) :: a(:)
    integer i
    do i = 1, size(a)
       call random_unit_vector(a(i))
    end do
  end subroutine arvec_random_unit

  subroutine arvec_stats(v, minv, maxv, meanv)
    type(rvec_t),intent(in)  :: v(:)
    type(rvec_t),intent(out) :: minv, maxv, meanv
    minv = minval(v)
    maxv = maxval(v)
    meanv = sum(v)/size(v)
  end subroutine arvec_stats
  function rvec_volume(a) ! Volume of a region
    type(rvec_t),intent(in) :: a
    integer :: rvec_volume
    rvec_volume = a%x*a%y 
  end function rvec_volume
  function scalarr_to_rvec(a) result (r)
    real(r_kind), intent(in) :: a
    type(rvec_t) r
    r = rvec_t(a,a)
  end function scalarr_to_rvec
  function scalari_to_rvec(a) result (r)
    integer, intent(in) :: a
    type(rvec_t) r
    r = scalarr_to_rvec(real(a,r_kind))
  end function scalari_to_rvec
  function isfinite_rvec(a) result(r)
    type(rvec_t), intent(in) :: a
    logical r
    r = isfinite(a%x) .and.  isfinite(a%y) 
  end function isfinite_rvec
  function isfinite_arvec(a) result(r)
    type(rvec_t), intent(in) :: a(:)
    logical r
    r = isfinite(a%x) .and.  isfinite(a%y) 
  end function isfinite_arvec
end module rvec_f90_def

